##本脚本由　by Han | 情非得已c，编写
#应用于搞机客上


Check_Magisk() {
    unzip -l "$File" $1 | grep -q $1
    return $?
}


if [[ -z "$File" ]]; then
    abort "请选择文件路径不可为空哦﻿⊙∀⊙！"
elif [[ ! -f "$File" ]]; then
    abort "\"${File}\"文件不存在无法此功能！"
fi

if ! Check_Magisk META-INF/com/google/android/updater-script; then
    error "！ 查看未知的压缩内部文件"
    unzip -l "$File" 1>&2
    sleep 2
    echo
    echo
    abort "！未从卡刷里找到META-INF/com/google/android/updater-script脚本文件，无法注入，请确保您选择的是卡刷包文件"
fi


echo "正在往卡刷包里添加Magisk"

File1=${File%.*}
File2=${File##*.}
File3="${File1}_and_Magisk.$File2"
Script=$TMPDIR/META-INF/com/google/android/updater-script

mkch -r $TMPDIR/Han.GJK


if $Option2; then
    [[ ! -f "$Magisk_File" ]] && abort "自定义的$Magisk_File 文件不存在无法注入！"
    cp -f "$Magisk_File" $TMPDIR/Han.GJK/magisk.zip
    unzip -oq "$Magisk_File" 'common/util_functions.sh' -d $TMPDIR
    MAGISK_VER=`grep_prop MAGISK_VER $TMPDIR/common/util_functions.sh`
    MAGISK_VER=`echo $MAGISK_VER | tr -d \"`
    MAGISK_VER_CODE=`grep_prop MAGISK_VER_CODE $TMPDIR/common/util_functions.sh`
    rm -rf $TMPDIR/common
    version="Magisk-$MAGISK_VER-($MAGISK_VER_CODE)".zip
else
    Choice=true
    . $SCRIPT/load_app_store-data.sh com.topjohnwu.magisk
    cp -f "$Download_File" $TMPDIR/Han.GJK/magisk.zip
    version="$name-$version($versionCode).zip"
fi

unzip -oq $File 'META-INF/com/google/android/updater-script' -d $TMPDIR

if ! Check_Magisk Han.GJK/magisk.zip; then
cat <<Han >>$Script
ui_print("- 开始安装 $version...");
ui_print("- 由「搞机客」一键注入");
run_program("/sbin/mkdir", "-p", "/tmp/Han.GJK");
package_extract_file("Han.GJK/magisk.zip", "/tmp/Han.GJK/magisk.zip");
run_program("/sbin/unzip", "-oq", "/tmp/Han.GJK/magisk.zip", "META-INF/com/google/android/update-binary", "-d", "/tmp/Han.GJK");
run_program("/sbin/sh", "/tmp/Han.GJK/META-INF/com/google/android/update-binary", "dummy", "1", "/tmp/Han.GJK/magisk.zip");
Han
fi


cd $TMPDIR
if ! $Option; then
    echo "已选择保留源文件……"
    cp -f "$File" "$File3"
    echo
    echo "开始打包……"
    zip -rq "$File3" ./*
    if [[ $? = 0 ]]; then
        echo "文件已保存到：$File3"
    else
        error "注入失败"
    fi
elif $Option; then
    echo "已选择不保留源文件……"
    echo
    echo "开始打包……"
    zip -rq "$File" ./*
    if [[ $? = 0 ]]; then
        echo "文件已保存到：$File"
    else
        error "注入失败"
    fi
fi

rm -rf $TMPDIR
