#本脚本由　by Han | 情非得已c，编写
#应用于搞机客上
# fun.sh
# 1.sh
# 3.sh
# 3a.sh
# 4.sh
# start
# export PS4='$LINENO: '
# set -x

Choice() {
    case "$1" in
        CQ)
            eval $2="开始重启手机"
        ;;
        
        Disable)
            eval $2="开始禁用所有模块后重启尝试一次开机"
        ;;
        
        CD_num)
            eval $2="开始禁用$3个模块（按最后修改时间排序），直到所有模块都被禁用才触发方案①②、无限重启除外"
        ;;
        
        Custom_Disabled)
            eval $2="开始自定义禁用指定模块"
        ;;
        
        recovery)
            eval $2="开始进入recovery模式"
        ;;
        
        Security_mode)
            eval $2="开始进入安全模式"
            echo -e "\n- 在安全模式下只会加载系统软件，重启手机即可退出安全模式"
        ;;
        
        9008)
            eval $2="开始进入9008模式"
        ;;
        
        fastboot)
            eval $2="开始进入FASTBOOT模式"
        ;;
        
        0)
            eval $2="无"
        ;;
    esac
}

Scheme4_Choice() {
case "$1" in
CQ)
cat <<Han >>$jian4
        Statistics
        _Log -2 '已重启手机'
        reboot
Han
;;

Disable)
cat <<Han >>$jian4
        Statistics
        Disable_All_Modules
Han
;;

CD_num)
cat <<Han >>$jian4
        Statistics
        Disable_Modules $2 $Riru4
Han
;;

Custom_Disabled)
cat <<Han >>$jian4
        Statistics
        Custom_Disabled $3
Han
;;

recovery)
cat <<Han >>$jian4
        Statistics
        _Log -2 已重启到rec恢复模式
        reboot recovery
Han
;;

Security_mode)
cat <<Han >>$jian4
        Statistics
        _Log -2 已重启到安全模式
        magisk resetprop persist.sys.safemode 1 && reboot
Han
;;

9008)
cat <<Han >>$jian4
        Statistics
        _Log -2 已重启到9008模式
        reboot edl
Han
;;

fastboot)
cat <<Han >>$jian4
        Statistics
        _Log -2 已重启到FASTBOOT模式
        reboot bootloader
Han
;;
esac
}

KEY_JZ() {
    echo "- 开始测试，请按下音量+"
    $KEYCHECK
    $KEYCHECK
    if [[ $? = $VOLUMEUP ]]; then
        echo "- 验证成功，音量+属性值=$VOLUMEUP"
        KEY_VOLUMEUP_value=$VOLUMEUP
        ceshi1=false
        echo "KEY_VOLUMEUP=$VOLUMEUP" >>$VOL_value
    else
        echo "- 验证失败音量+属性值不等于：$VOLUMEUP"
        ceshi1=true
        return 1
    fi
        echo "- 请按下音量-"
        $KEYCHECK
        $KEYCHECK
        if [[ $? = $VOLUMEDOWN ]]; then
            echo "- 验证成功，音量-属性值=$VOLUMEDOWN"
            KEY_VOLUMEDOWN_value=$VOLUMEDOWN
            echo "KEY_VOLUMEDOWN=$VOLUMEDOWN" >>$VOL_value
            ceshi1=false
        else
            echo "- 验证失败音量-属性值不等于：$VOLUMEDOWN"
            ceshi1=true
            return 1
        fi
            return 0
}

_md5() {
    local md51="`md5sum2 $1`"
    local md52="`md5sum2 $2 2>/dev/null`"
    if [[ $md51 = $md52 ]]; then
        echo "- $2文件已存在，不再重复复制"
        return 0
    else
        cp -f "$1" "$2"
        chmod 700 "$2"
        return 1
    fi
}



: >"$CONFIG_DIR/$1.log"
while read i; do
    eval echo $i=\$$i >>"$CONFIG_DIR/$1.log"
done <<Han
ChongQi
RUN_THE_RECORD
Scheme2
CS
Clean
sapp
SELinux
Frequency
Compulsory_Rescue
update
dpi
size
UI
Riru3
Set_Time
Automatic
CD_num3
Scheme4
Set_Time4
Record_volume_button
Riru4
Volume_button_frequency
KEY_VOLUMEUP
CD_num_UP
Specifies_MOD_Disable_UP
KEY_VOLUMEDOWN
CD_num_DOWN
Specifies_MOD_Disable_DOWN
Han


mask -vc
if [[ "`grep_prop init.svc.bootanim`" != "stopped" ]]; then
    abort "！未支持您的设备请联系我适配，错误代码：`grep_prop init.svc.bootanim`"
fi
    if $Scheme2 && { $Clean || $SELinux || $sapp || $UI; }; then
        if [[ $Frequency -le $CS ]]; then
            echo "- 当前设置方案①重启次数=$CS"
            echo "- 当前设置方案②重启次数=$Frequency"
            abort "！方案②的重启次数小于或等于方案①设置的重启次数无法安装，方案②重启次数设置至少要比方案①大1"
        fi
    fi
            echo "$Set_Time" | egrep 'm|s' && abort "！设置的时间不能带单位，只允许数字和小数点"

MODID=$1
mask -m $MODID
. $MWD $MODID
Han=$Module/Han
jian1=$Han/1.sh
jian3=$Han/3.sh
jian3a=$Han/3a.sh
jian4=$Han/4.sh
num=$Han/Number_of_times.log
SystemVersion=$Han/SystemVersion.log
fun=$Han/fun.sh
Bin_Dir=$Module/bin
VOL_value=$CONFIG_DIR/${1}-VV.log
error=`which error`
CQ=`which CQ`

find $Han ! -name 'Number_of_times.log' ! -name 'disable_list_*.log' -delete &>/dev/null
find $Module -maxdepth 1 -type f -delete &>/dev/null
[[ ! -d $Han ]] && mkdir -p $Han
[[ ! -d $Bin_Dir ]] && mkdir $Bin_Dir
cat <<Han | grep -qw CD_num && echo -e "已选择「禁用一个模块（按修改时间依次禁用）」每次仅禁用一个\n为了避免和方案①②冲突，直到所有模块都被禁用后再触发方案①②（无限重启时除外）\n"
$Automatic
$KEY_VOLUMEUP
$KEY_VOLUMEDOWN
Han

    if ! $Scheme2; then
        Clean=false
        SELinux=false
        sapp=false
        UI=false
        $error "！温馨提示：您没有开启方案①"
    else
        if { $Clean || $SELinux || $sapp; }; then
            Frequency=$((Frequency+1))
            FA2=$((CS+1))
        else
            FA2=$CS
        fi
    fi
        if ! $Scheme4; then
            Record_volume_button=false
            Volume_button_frequency=0
            KEY_VOLUMEUP=0
            KEY_VOLUMEDOWN=0
            $error "！温馨提示：您没有开启方案④"
        elif [[ $KEY_VOLUMEUP = 0 && $KEY_VOLUMEDOWN = 0 ]]; then
            $error "！温馨提示：您已开启方案④，但是音量执行操作都是：无"
        fi
            if [[ $KEY_VOLUMEUP != 0 || $KEY_VOLUMEDOWN != 0 ]]; then
                case "$ABI" in
                    arm64*) Type=arm64;;
                    arm*) Type=arm;;
                    x86_64*) Type=x86_64;;
                    x86*) Type=x86;;
                    *) abort "未知架构$ABI，无法安装keycheck，请关闭方案4开关重试"
                esac
                    if [[ $PACKAGE_NAME = Han.GJK ]]; then
                        KEYCHECK=$ELF2_PATH/keycheck
                    else
                        KEYCHECK=$PREFIX/ELF/keycheck-$Type
                    fi
            fi
                        echo "- 正在创建运行环境"
                        echo "- 正在检测文件MD5。避免重复复制"
                        unset bb
                        [[ -f $ELF4_PATH/busybox ]] && bb=$ELF4_PATH/busybox
                        [[ -z $bb ]] && bb=/data/adb/magisk/busybox
                        
                        [[ $KEY_VOLUMEUP != 0 || $KEY_VOLUMEDOWN != 0 ]] && _md5 $KEYCHECK $Bin_Dir/keycheck
                        _md5 $bb $Bin_Dir/busybox || $Bin_Dir/busybox --install -s $Bin_Dir
                        [[ ! -x $Bin_Dir/which ]] && _md5 "$which" $Bin_Dir/which
                        [[ -z $SHELL ]] && SHELL=`which sh`
                        PATH="$Bin_Dir:$PATH0"
                        KEYCHECK=$Bin_Dir/keycheck
                        busybox 1>/dev/null || abort "！没有/data/adb/magisk/busybox文件，请先修复Magisk运行环境"
                            if $SELinux; then
                                if [[ -z `$which setenforce` ]]; then
                                    if [[ ! -f "$ELF4_PATH/busybox" ]]; then
                                        setenforce='#'
                                    else
                                        echo "- 检测到系统缺少命令，开始复制busybox"
                                        _md5 "$ELF4_PATH/busybox" $Han/busybox
                                        setenforce="\$MODDIR/Han/busybox setenforce"
                                    fi
                                else
                                    setenforce=setenforce
                                fi
                            fi
                            
                                echo
                                echo "- 检测已选择的选项是否适配您的机型"
                                if $UI; then
                                    echo "- 「检测系统界面UI」功能是否适配您的机型？"
                                    pm list package -s | egrep -q ':com.android.systemui$' || abort -e "！com.android.systemui包名不存在\n！「检测系统界面UI」未适配您的机型，请取消勾选后重新安装"
                                    echo -n "- 当前系统界面UI进程："
                                    if ! pidof com.android.systemui; then
                                        abort "！「检测系统界面UI」未适配您的机型，请取消勾选后重新安装，或发送邮件我适配"
                                    fi
                                fi
                                    if $dpi; then
                                        echo "- 「检测屏幕DPI」功能是否适配您的机型？"
                                        now_dpi=`wm density | awk 'END{print $NF}'`
                                        echo "- 当前屏幕DPI：$now_dpi"
                                        echo "$now_dpi" | egrep -q '[0-9]+' || abort "！未知屏幕dpi：$now_dpi，请关闭「检测屏幕DPI」对勾后重新安装或发送邮件我适配"
                                    fi
                                        if $size; then
                                            echo "-「锁定屏幕分辨率大小」功能是否适配您的机型？"
                                            Screen_Size=`wm size | awk 'END{print $NF}'`
                                            echo "- 当前屏幕分辨率：$Screen_Size"
                                            echo "$Screen_Size" | egrep -q '[0-9]+x[0-9]+' || abort "！未知屏幕分辨率：$size，请关闭「锁定屏幕分辨率大小」对勾后重新安装或发送邮件我适配"
                                        fi
                                            if $update; then
                                                echo "- 「系统更新后第一次开机时停用$name」是否适配您的机型？"
                                                v=`grep_prop ro.build.version.incremental`
                                                [[ -z $v ]] && abort "！未找到ro.build.version.incremental属性，请取消「系统升级后禁用方案③」对勾后重新安装或发送邮件我适配" 
                                                echo "- 当前ROM版本：$v"
                                                echo "$v" >$SystemVersion
                                            else
                                                v=`grep_prop ro.build.version.incremental`
                                            fi
                                                Choice0=
                                                if $Clean || $sapp || $SELinux; then
                                                    Choice0="在重启第$CS次时"
                                                    $Clean && Choice0+="清除系统包名缓存、"
                                                    $sapp && Choice0+="恢复已冻结应用、"
                                                    $SELinux && Choice0+="关闭SELinux、"
                                                    Choice0+="尝试第$FA2次开机操作。"
                                                fi
                                                    if [[ $KEY_VOLUMEUP != 0 || $KEY_VOLUMEDOWN != 0 ]]; then
                                                        if [[ -f $VOL_value ]]; then
                                                            KEY_VOLUMEUP_value=`grep_prop KEY_VOLUMEUP $VOL_value`
                                                            KEY_VOLUMEDOWN_value=`grep_prop KEY_VOLUMEDOWN $VOL_value`
                                                            old_v=`grep_prop SystemVersion $VOL_value`
                                                            
                                                            [[ -z $KEY_VOLUMEUP_value || -z $KEY_VOLUMEDOWN_value || -z $old_v ]] && $error "！检测到未录制音量键属性，已强制勾选「录制音量键属性」" && Record_volume_button=true
                                                            echo "- 已录制音量键属性值"
                                                            echo "- 音量+：$KEY_VOLUMEUP_value"
                                                            echo "- 音量-：$KEY_VOLUMEDOWN_value"
                                                            if [[ $old_v != $v ]]; then
                                                                echo "！系统有升级过开始重新验证，查看属性是否有变化，防止方案④无效"
                                                                VOLUMEUP=$KEY_VOLUMEUP_value
                                                                VOLUMEDOWN=$KEY_VOLUMEDOWN_value
                                                                KEY_JZ && sed -i "/SystemVersion=/c SystemVersion=$v" $VOL_value || Record_volume_button=true
                                                                sort -u $VOL_value -o $VOL_value
                                                            fi
                                                        else
                                                            $error "！检测到未录制音量键属性，已强制勾选「录制音量键属性」。"
                                                            Record_volume_button=true
                                                        fi
                                                    fi
                                                        if $Record_volume_button && [[ $KEY_VOLUMEUP != 0 || $KEY_VOLUMEDOWN != 0 ]]; then
                                                            if [[ -x $KEYCHECK ]]; then
                                                                ceshi=true
                                                                echo "SystemVersion=$v" >$VOL_value 
                                                                while $ceshi1; do
                                                                    echo "- 已选择方案④，开始录入音量键属性值"
                                                                    echo "- 请按下音量+"
                                                                    $KEYCHECK
                                                                    $KEYCHECK
                                                                    VOLUMEUP=$?
                                                                    echo "- 请按下音量-"
                                                                    $KEYCHECK
                                                                    $KEYCHECK
                                                                    VOLUMEDOWN=$?
                                                                    
                                                                    if [[ $VOLUMEDOWN = $VOLUMEUP ]]; then
                                                                        $error "录入错误请根据提示正确的按下音量键，如果始终无法录制成功请关闭方案4开关后重新安装"
                                                                        continue
                                                                        echo "- 2秒后重新录制"
                                                                        sleep 2
                                                                    fi
                                                                        KEY_JZ
                                                                done
                                                            else
                                                                abort "！keycheck命令不存在"
                                                            fi
                                                        fi


Choice $Automatic Choice3 $CD_num3
Choice $KEY_VOLUMEUP Choice41 $CD_num_UP
Choice $KEY_VOLUMEDOWN Choice42 $CD_num_DOWN

ls -tc $ENV_FILE >/dev/null && lsml='ls -tc' || lsml=ls
# start
cat <<Han >$Module_S
#!$SHELL
# 下载地址：https://han.lanzoui.com/b03c2iqbi      密码：Han
# 签名MD5：fe37540cd55ce1a86673cbc7b16c6c36
# 作者：$author
# 反馈建议：243454893@qq.com
# 请不要试图篡改本模块任何脚本，否则一切后果自负，已安装版本：$version($versionCode)
# Powered by Magisk


Han
cp -f $Module_S $Module_S2

cat <<Han >>$Module_S
export MODDIR=\${0%/*}
export PATH="\$MODDIR/bin:\$PATH"
$SHELL \$MODDIR/Han/1.sh
exit 0
Han

cat <<Han >>$Module_S2
export MODDIR=\${0%/*}
export PATH="\$MODDIR/bin:\$PATH"
$SHELL \$MODDIR/Han/k4.sh &
$SHELL \$MODDIR/Han/4.sh &
$SHELL \$MODDIR/Han/3a.sh &
$SHELL \$MODDIR/Han/3.sh
exit 0
Han




if [[ $KEY_VOLUMEUP = Custom_Disabled ]]; then
    [[ -z $Specifies_MOD_Disable_UP ]] && abort "已选择按音量+禁用指定模块，请至少选中一个模块"
cat <<Han >$Han/disable_list_UP.log
$Specifies_MOD_Disable_UP
Han
fi

if [[ $KEY_VOLUMEDOWN = Custom_Disabled ]]; then
    [[ -z $Specifies_MOD_Disable_DOWN ]] && abort "已选择按音量-禁用指定模块，请至少选中一个模块"
cat <<Han >$Han//disable_list_DOWN.log
$Specifies_MOD_Disable_DOWN
Han
fi





# fun.sh
cat <<Han >$fun
MODID=\${MODDIR##*/}
RUN_THE_RECORD=\$MODDIR/运行记录.txt
Module_XinXi=\$MODDIR/module.prop
START_LOG=\$MODDIR/Han/Start.log
ENABLED_UI=\$MODDIR/Han/enabled_UI
KEY=\$MODDIR/Han/KEY
LOG=\$MODDIR/Han/Number_of_times.log
DISABLE_NUM=\$MODDIR/Han/disable.log
KEYCHECK=\$MODDIR/bin/keycheck
VOLUMEUP=$KEY_VOLUMEUP_value
VOLUMEDOWN=$KEY_VOLUMEDOWN_value
Modules_Dir=$Modules_Dir


_Log() {
    date '+%Y-%m-%d %H:%M:%S'
    [[ \$1 = -2 ]] && echo -n '! ' && shift || echo -n '- '
    echo "\$@"
    echo
} >>\$RUN_THE_RECORD

_Log_a() {
    [[ \$1 = -2 ]] && echo -n '! ' && shift || echo -n '- '
    echo "\$@"
} >>\$RUN_THE_RECORD

grep_prop() {
    if [[ -z "\$2" ]]; then
        which getprop &>/dev/null && getprop "\$1" || magisk resetprop "\$1"
        return \$?
    elif [[ -f "\$2" ]]; then
        result=\`sed -rn "s/^\$1=//p" "\$2" | head -n 1\`
        [[ -z "\$result" ]] && return 1
        cat <<-Han
			\$result
		Han
    else
        return 22
    fi
        return 0 
}

MOD_list() {
    if [[ \$1 = 1 ]]; then
        $lsml \$p | egrep -v '^riru-core$'
        echo 'riru-core'
    else
        $lsml \$p
    fi
}

Custom_Disabled() {
    local IFS=\$'\n'
    while read c; do
    local MODNAME=
    MODNAME=\`grep_prop name "\$Modules_Dir/\$c/module.prop"\`
        if [[ -f "\$Modules_Dir/\$c/disable" ]]; then
            echo "- 「\$MODNAME」已在禁用状态中"
            continue
        fi
            if [[ -d "\$Modules_Dir/\$c/disable" ]]; then
                rm -rf "\$Modules_Dir/\$c/disable"
            fi
                echo "! 已禁用了「\$MODNAME」"
                touch "\$Modules_Dir/\$c/disable" >/dev/null
    done < \$MODDIR/Han/disable_list_\$1.log
} >>\$RUN_THE_RECORD 2>&1

Disable_Modules() {
    {
    num=0
    local IFS=\$'\n'
    for p in /data/adb/modules /data/adb/lite_modules; do
        [[ ! -d \$p ]] && continue
        while read d; do
            [[ "\$d" = "\$MODID" ]] && continue
            local MODNAME=
            MODNAME=\`grep_prop name "\$p/\$d/module.prop"\`
            if [[ -f "\$p/\$d/disable" ]]; then
                echo "- 「\$MODNAME」已在禁用状态中"
                continue
            fi
                if [[ -d "\$p/\$d/disable" ]]; then
                    rm -rf "\$p/\$d/disable"
                fi
                    echo -n "! 已禁用了「\$MODNAME」，最后修改时间："
                    stat -c "%z" "\$p/\$d" | sed -r 's/ \+.*//'
                    touch "\$p/\$d/disable" >/dev/null
                    num=\`expr \$num + 1\`
                    if [[ \$1 = \$num ]]; then
                        echo 'disable' >\$START_LOG
                        break 2
                    fi
        done<<EOF
\$(MOD_list \$2)
EOF
    done
    echo 
    } >>\$RUN_THE_RECORD 2>&1
    _Log -2 '已重启手机'
    reboot
}

Disable_All_Modules() {
    {
    local IFS=\$'\n'
    for p in /data/adb/modules /data/adb/lite_modules; do
        [[ -d \$p ]] && $lsml \$p | while read m; do
            [[ "\$m" = "\$MODID" ]] && continue
            local MODNAME=
            MODNAME=\`grep_prop name "\$p/\$m/module.prop"\`
            if [[ -f "\$p/\$m/disable" ]]; then
                echo "- 「\$MODNAME」已在禁用状态中"
                continue
            fi
                if [[ -d "\$p/\$m/disable" ]]; then
                    rm -rf "\$p/\$m/disable"
                fi
                    echo -n "! 已禁用了「\$MODNAME」，最后修改时间："
                    stat -c "%z" "\$p/\$m" | sed -r 's/ \+.*//'
                    touch "\$p/\$m/disable" >/dev/null
        done
    done
    echo 
    } >>\$RUN_THE_RECORD 2>&1
    _Log -2 '已重启手机'
    reboot
}

Statistics() {
    if [[ ! -f \$LOG ]]; then
        echo "1" >\$LOG
    else
        number_of_times=\`cat \$LOG\`
        expr \$number_of_times + 1 >\$LOG
    fi
}
Han





# 4.sh
unset Choice4
if [[ $KEY_VOLUMEUP != 0 || $KEY_VOLUMEDOWN != 0 ]]; then
    Choice4="（"
    Choice4+="已开启方案④您可在进入第二屏后$Set_Time4秒内"
    [[ $KEY_VOLUMEUP != 0 ]] && Choice4+="按下音量+ $Volume_button_frequency次后执行：$Choice41、"
    [[ $KEY_VOLUMEDOWN != 0 ]] && Choice4+="按下音量- $Volume_button_frequency次后执行：$Choice42"
    Choice4+="）"

cat <<Han >$Han/k4.sh
. \$MODDIR/Han/fun.sh

    _Log 已限定方案④在$Set_Time4秒内有效
    sleep $Set_Time4
    _Log $Set_Time4秒过去了，开始终止方案④PID……
    pkill -9 -f "\$MODDIR/Han/4.sh"
    while pgrep -f "\$KEYCHECK" &>/dev/null; do
        pkill -9 -f "\$KEYCHECK"
    done
        pgrep -f "\$KEYCHECK" &>/dev/null && _Log_a -2 "进程终止异常."
        pgrep -f "\$MODDIR/Han/4.sh" &>/dev/null && _Log_a -2 "进程终止异常.."
        exit 0
Han

cat <<Han >$jian4
. \$MODDIR/Han/fun.sh

Volume_button_selection() {
    \$KEYCHECK
    \$KEYCHECK
    RESULT=\$?
    if [[ \$RESULT = \$VOLUMEUP ]]; then
        echo \$RESULT >>\$KEY
        _Log '已按下一次音量+'
    elif [[ \$RESULT = \$VOLUMEDOWN ]]; then
        echo \$RESULT >>\$KEY
        _Log '已按下一次音量-'
    else
        _Log -2 "音量键属性值录制错误请重新安装本模块，并勾选「录制音量键属性」"
    fi
}


Han

if [[ $KEY_VOLUMEUP != 0 && $KEY_VOLUMEDOWN != 0 ]]; then
cat <<Han >>$jian4
up=0
down=0
until [[ \$up -ge $Volume_button_frequency || \$down -ge $Volume_button_frequency ]]; do
    Volume_button_selection
    up=\`grep -c "\$VOLUMEUP" \$KEY\`
    down=\`grep -c "\$VOLUMEDOWN" \$KEY\`
done

    if [[ \$up -ge $Volume_button_frequency ]]; then
        _Log 已按下\$up次音量+，$Choice41
Han

Scheme4_Choice $KEY_VOLUMEUP $CD_num_UP UP
cat <<Han >>$jian4
    elif [[ \$down -ge $Volume_button_frequency ]]; then
        _Log 已按下\$down次音量-，$Choice42
Han

Scheme4_Choice $KEY_VOLUMEDOWN $CD_num_DOWN DOWN
elif [[ $KEY_VOLUMEUP != 0 && $KEY_VOLUMEDOWN = 0 ]]; then
cat <<Han >>$jian4
up=0
until [[ \$up -ge $Volume_button_frequency ]]; do
    Volume_button_selection
    up=\`grep -c "\$VOLUMEUP" \$KEY\`
done

    if [[ \$up -ge $Volume_button_frequency ]]; then
        _Log 已按下\$up次音量+，$Choice41
Han

Scheme4_Choice $KEY_VOLUMEUP $CD_num_UP UP

elif [[ $KEY_VOLUMEUP = 0 && $KEY_VOLUMEDOWN != 0 ]]; then
cat <<Han >>$jian4
down=0
until [[ \$down -ge $Volume_button_frequency ]]; do
    Volume_button_selection
    down=\`grep -c "\$VOLUMEDOWN" \$KEY\`
done

    if [[ \$down -ge $Volume_button_frequency ]]; then
        _Log 已按下\$down次音量-，$Choice42
Han

Scheme4_Choice $KEY_VOLUMEDOWN $CD_num_DOWN DOWN
fi

cat <<'Han' >>$jian4
    fi
        _Log 方案④运行结束，开始自杀终止PID……
        pkill -9 -f "$MODDIR/"
        _Log_a -2 "进程终止异常"
        exit 0
Han
fi





# 1.sh
cat <<Han >$jian1
. \$MODDIR/Han/fun.sh
: >\$KEY

if [[ ! -f \$START_LOG ]]; then
    Frequency2=0
    c=0
    : >\$RUN_THE_RECORD
    _Log "第1次启动，当前版本：$version($versionCode)"
else
    Frequency=\`cat \$START_LOG\`
    if [[ "\$Frequency" = "pm" ]]; then
        Frequency2=0
        c=0
        _Log 系统界面被冻结后第2次启动
    elif [[ "\$Frequency" = "update" ]]; then
        Frequency2=0
        _Log 系统更新后第2次启动
        c=1
    elif [[ "\$Frequency" = "disable" ]]; then
        Frequency2=0
        c=0
        [[ -f \$DISABLE_NUM ]] && mod_num=\`cat \$DISABLE_NUM\` || mod_num=1
        d=\`expr \$mod_num + 1\`
        echo "\$d" >\$DISABLE_NUM
        _Log 禁用\$mod_num个模块后第\$d次启动
    else
        Frequency2="\`expr \$Frequency + 1\`"
        c=\$Frequency2
        _Log 第\$(expr \$c + 1)次启动
    fi
fi

    echo "\$c" >"\$START_LOG"

Han

    unset ml
    if $Clean && $sapp; then
        ml='rm -f /data/system/package_cache/*
        rm -f /data/system/users/0/package-restrictions.xml
        _Log -2 已删除系统包名缓存和已恢复冻结应用'
    elif $Clean; then
        ml='rm -f /data/system/package_cache/*
        _Log -2 已删除系统包名缓存'
    elif $sapp; then
        ml='rm -f /data/system/users/0/package-restrictions.xml
        _Log -2 已恢复冻结应用'
    fi

if $Clean || $sapp ; then
cat <<Han >>$jian1
    if [[ \$Frequency2 -eq $CS ]]; then
        $ml
        Statistics
        _Log -2 已重启手机
        reboot
Han
fi


case "$Compulsory_Rescue" in
Disable_and_recovery | Disable_and_fastboot | Disable_and_9008 | Disable_and_Security_mode)
FA3=$((Frequency+2))
if $SELinux; then
cat <<Han >>$jian1
    elif [[ \$Frequency2 -eq $FA2 ]]; then
        $setenforce 0
        echo 0 >/sys/fs/selinux/enforce
        _Log -2 已关闭SELinux尝试第\$Frequency2次开机
    elif [[ \$Frequency2 -eq $Frequency ]]; then
Han
elif $Clean; then
cat <<Han >>$jian1
    elif [[ \$Frequency2 -eq $Frequency ]]; then
Han
else
cat <<Han >>$jian1
    if [[ \$Frequency2 -eq $Frequency ]]; then
Han
fi
;;

*)
if $SELinux; then
cat <<Han >>$jian1
    elif [[ \$Frequency2 -eq $FA2 ]]; then
        $setenforce 0
        echo 0 >/sys/fs/selinux/enforce
        _Log -2 已关闭SELinux尝试第\$Frequency2次开机
    elif [[ \$Frequency2 -ge $Frequency ]]; then
Han
elif $Clean; then
cat <<Han >>$jian1
    elif [[ \$Frequency2 -eq $Frequency ]]; then
Han
else
cat <<Han >>$jian1
    if [[ \$Frequency2 -eq $Frequency ]]; then
Han
fi
;;
esac


x="同时删除记录启动次数的文件，重新记录"
case "$Compulsory_Rescue" in
Disable_and_recovery)
Choice2="禁用所有模块开机一次后仍无法进入系统后最终进入recovery模式，$x"
cat <<Han >>$jian1
        chmod 000 /data/adb/service.d/* /data/adb/post-fs-data.d/*
        _Log -2 -e "已强制将/data/adb/service.d/和/data/adb/post-fs-data.d/目录下文件权限设置为0\n！ 防止有模块将脚本放在此处影响正常开机"
        Statistics
        Disable_All_Modules
    elif [[ \$Frequency2 -ge $FA3 ]]; then
        rm -f "\$START_LOG"
        Statistics
        _Log -2 已重启到rec恢复模式
        mv -f \$RUN_THE_RECORD \$RUN_THE_RECORD.bak
        reboot recovery
    fi
Han
;;

Disable_and_fastboot)
Choice2="禁用所有模块开机一次后仍无法进入系统后最终进入FASTBOOT模式，$x"
cat <<Han >>$jian1
        chmod 000 /data/adb/service.d/* /data/adb/post-fs-data.d/*
        _Log -2 -e "已强制将/data/adb/service.d/和/data/adb/post-fs-data.d/目录下文件权限设置为0\n！ 防止有模块将脚本放在此处影响正常开机"
        Statistics
        Disable_All_Modules
    elif [[ \$Frequency2 -ge $FA3 ]]; then
        rm -f "\$START_LOG"
        Statistics
        _Log -2 已重启到FASTBOOT模式
        mv -f \$RUN_THE_RECORD \$RUN_THE_RECORD.bak
        reboot bootloader
    fi
Han
;;

Disable_and_9008)
Choice2="禁用所有模块开机一次后仍无法进入系统后最终进入9008模式，$x"
cat <<Han >>$jian1
        chmod 000 /data/adb/service.d/* /data/adb/post-fs-data.d/*
        _Log -2 -e "已强制将/data/adb/service.d/和/data/adb/post-fs-data.d/目录下文件权限设置为0\n！ 防止有模块将脚本放在此处影响正常开机"
        Statistics
        Disable_All_Modules
    elif [[ \$Frequency2 -ge $FA3 ]]; then
        rm -f "\$START_LOG"
        Statistics
        _Log -2 已重启到9008模式
        mv -f \$RUN_THE_RECORD \$RUN_THE_RECORD.bak
        reboot edl
    fi
Han
;;

Disable_and_Security_mode)
Choice2="禁用所有模块开机一次后仍无法进入系统后最终进入安全模式，$x"
cat <<Han >>$jian1
        chmod 000 /data/adb/service.d/* /data/adb/post-fs-data.d/*
        _Log -2 -e "已强制将/data/adb/service.d/和/data/adb/post-fs-data.d/目录下文件权限设置为0\n！ 防止有模块将脚本放在此处影响正常开机"
        Statistics
        Disable_All_Modules
    elif [[ \$Frequency2 -ge $FA3 ]]; then
        rm -f "\$START_LOG"
        Statistics
        _Log -2 已重启到安全模式
        mv -f \$RUN_THE_RECORD \$RUN_THE_RECORD.bak
        magisk resetprop persist.sys.safemode 1 && reboot
    fi
Han
;;

recovery)
Choice2="进入recovery，$x"
cat <<'Han' >>$jian1
        rm -f "$START_LOG"
        Statistics
        _Log -2 已重启到rec恢复模式
        mv -f \$RUN_THE_RECORD \$RUN_THE_RECORD.bak
        reboot recovery
    fi
Han
;;

Security_mode)
Choice2="进入安全模式，$x"
echo "- 在安全模式下只会加载系统软件，重启手机即可退出安全模式"

cat <<'Han' >>$jian1
        rm -f "$START_LOG"
        Statistics
        _Log -2 已重启到安全模式
        mv -f \$RUN_THE_RECORD \$RUN_THE_RECORD.bak
        magisk resetprop persist.sys.safemode 1 && reboot
    fi
Han
;;

fastboot)
Choice2="进入FASTBOOT，$x"
cat <<'Han' >>$jian1
        rm -f "$START_LOG"
        Statistics
        _Log -2 已重启到FASTBOOT模式
        mv -f \$RUN_THE_RECORD \$RUN_THE_RECORD.bak
        reboot bootloader
    fi
Han
;;

9008)
Choice2="进入9008，$x"
cat <<'Han' >>$jian1
        rm -f "$START_LOG"
        Statistics
        _Log -2 已重启到9008模式
        mv -f \$RUN_THE_RECORD \$RUN_THE_RECORD.bak
        reboot edl
    fi
Han
;;
esac


cat <<'Han' >>$jian1
        _Log post-fs-data.sh 运行结束。
        exit 0
Han





# 3a.sh
cat <<Han >$jian3a
. \$MODDIR/Han/fun.sh

until [[ "\`grep_prop init.svc.bootanim\`" = "stopped" ]]; do
    sleep 1
done

Han

Choice3a=
if $dpi || $size; then
    Choice3a="已成功开机后发现屏幕"
    if $dpi && $size; then
        Choice3a+="DPI和分辨率"
    elif $dpi; then
        Choice3a="DPI"
    elif $size; then
        Choice3a="分辨率"
    fi
        Choice3a+="不正常时自动恢复默认，"
        $UI && Choice3a+="检测到系统UI被冻结时自动启用后重启手机，检测系统界面UI进程不存在时，$Choice3。"

cat <<'Han' >>$jian3a
    until wm density | egrep -q '[0-9]+'; do
        _Log -2 未检测到屏幕属性值，2秒后重新检测
        sleep 2
    done
Han
fi

if $dpi; then
cat <<'Han' >>$jian3a

        (
        dpi=`wm density | awk 'END{print $NF}'`
        if [[ $dpi -lt 250 || $dpi -ge 700 ]]; then
            wm density reset
            Statistics
            _Log -2 -e "当前屏幕dpi：$dpi\n！ 已检测到屏幕dpi设置异常！不在250-700之间，已为您恢复默认"
        fi
        )
Han
fi

if $size; then
cat <<Han >>$jian3a

            (
            old_size="$Screen_Size"
            now_size="\`wm size | awk 'END{print \$NF}'\`"
            if [[ "\$old_size" != "\$now_size" ]]; then
                wm size reset
                Statistics
                _Log -2 -e "当前屏幕分辨率：\$now_size\n！ 已检测到屏幕分辨率设置异常！不等于\$old_size，已为您恢复默认"
            fi
            )
Han
fi

if $UI; then
cat <<'Han' >>$jian3a
                (
                if pm list package -d | egrep -q ':com.android.systemui$'; then
                    if [[ -f $ENABLED_UI ]]; then
                        _Log -2 已启用过一次系统界面了，但是貌似启用失败了，emmmmmm
                    else
                        sed -i '/"com.android.systemui"/d' /data/system/users/0/package-restrictions.xml
                        pm enable com.android.systemui 
                        _Log -2 系统界面：com.android.systemui，已被冻结已重新启用并重启手机
                        Statistics
                        echo 'pm' >$START_LOG
                        touch $ENABLED_UI
                        reboot
                    fi
                fi
                )
                        if ! pidof com.android.systemui &>/dev/null; then
                            _Log -2 系统界面UI进程不存在
                            Statistics
Han
case "$Automatic" in
Disable)
cat <<Han >>$jian3a
                            Disable_All_Modules
                            exit 0
                        fi
Han
;;

CD_num)
cat <<Han >>$jian3a
                            Disable_Modules $CD_num3 $Riru3
                            exit 0
                        fi
Han
;;

recovery)
cat <<Han >>$jian3a
                            _Log -2 已重启到rec恢复模式
                            reboot recovery
                            exit 0
                        fi
Han
;;

Security_mode)
cat <<Han >>$jian3a
                            _Log -2 已重启到安全模式
                            magisk resetprop persist.sys.safemode 1 && reboot
                            exit 0
                        fi
Han
;;

9008)
cat <<Han >>$jian3a
                            _Log -2 已重启到9008模式
                            reboot edl
                            exit 0
                        fi
Han
;;

fastboot)
cat <<Han >>$jian3a
                            _Log -2 已重启到FASTBOOT模式
                            reboot bootloader
                            exit 0
                        fi
Han

;;
esac
fi

cat <<Han >>$jian3a
                            exit 0
Han





# 3.sh
cat <<Han >$jian3
. \$MODDIR/Han/fun.sh

if [[ -f \$START_LOG ]]; then
    mv -f \$Module_XinXi.bak \$Module_XinXi && sed -i '3,5d' "\$MODDIR/Han/3.sh"
fi

Han

description="当刷入一些模块后导致无法正常开机时，触发已设置的自动救砖操作方式：$Choice3a在第二屏等待$Set_Time分钟后无法开机，自动$Choice3，$Choice0如果再重启第$Frequency次时未开机，强制$Choice2。$Choice4"
if $update; then
    description="已选择系统更新后第一次开机时停用，再第二次重启时再继续触发。当刷入一些模块后导致无法正常开机时，触发已设置的自动救砖操作方式：在$Choice3a在第二屏等待$Set_Time分钟后无法开机，自动$Choice3$Choice4。$Choice0如果再重启第$Frequency次时未开机，强制$Choice2。"

    cat <<'Han' >>$jian3
    version=`cat $MODDIR/Han/SystemVersion.log`
    now_version=`grep_prop ro.build.version.incremental`
    Frequency=`cat $START_LOG`
    if [[ "$now_version" != "$version" && $Frequency = 0 ]]; then
        echo "$now_version" >$MODDIR/Han/SystemVersion.log
        echo "update" >$START_LOG
        _Log "已选择系统更新后第一次开机时停用「神仙自动救砖」"
        exit 0
    fi

Han
fi
        $RUN_THE_RECORD && description+="运行记录文件在：$Module/运行记录.txt。"

cat <<Han >>$jian3
        _Log 已限定第二屏等待时间为：${Set_Time}分钟
        sleep ${Set_Time}m
        _Log -n ${Set_Time}分钟过去了﻿，当前状态：\`grep_prop init.svc.bootanim\`
        if [[ "\`grep_prop init.svc.bootanim\`" = "running" ]]; then
            _Log_a -2 "您的设备未成功开机 😱😱"
            Statistics
Han


case "$Automatic" in

Disable)
cat <<Han >>$jian3
            Disable_All_Modules
            exit 0
        fi
Han
;;

CD_num)
cat <<Han >>$jian3
            Disable_Modules $CD_num3 $Riru3
            exit 0
        fi
Han
;;

recovery)
cat <<Han >>$jian3
            _Log -2 已重启到rec恢复模式
            reboot recovery
            exit 0
        fi
Han
;;

Security_mode)
cat <<Han >>$jian3
            _Log -2 已重启到安全模式
            magisk resetprop persist.sys.safemode 1 && reboot
            exit 0
        fi
Han
;;

9008)
cat <<Han >>$jian3
            _Log -2 已重启到9008模式
            reboot edl
            exit 0
        fi
Han
;;

fastboot)
cat <<Han >>$jian3
            _Log -2 已重启到FASTBOOT模式
            reboot bootloader
            exit 0
        fi
Han

;;
esac


cat <<Han >>$jian3
            if [[ -f \$LOG ]]; then
                number_of_times=\`cat \$LOG\`
                sed -i "/^description=/c description=$description已为您自动/手动服务：\$number_of_times次。" "\$Module_XinXi"
                _Log_a "已成功开机了 😋😋，「$name」已为您自动/手动服务：\$number_of_times次。"
            else
                _Log_a "已成功开机了 😋😋"
            fi
                rm -f "\$START_LOG" "\$ENABLED_UI" "\$DISABLE_NUM"
                _Log_a service.sh 运行结束，开始自杀终止PID……
                pkill -9 -f "\$MODDIR/"
                _Log_a "! 进程终止异常"
                pgrep -f "\$MODDIR/" >>\$RUN_THE_RECORD 2>&1
                exit 0
Han





printf "id=$MODID
name=$name-等待重启中
version=$version
versionCode=$versionCode
author=$author
description=正在等待重启后，测试Magisk开机时是否能够执行post-fs-data.sh和service.sh，如果无法成功执行，名称将一直是：$name-等待重启中，请联系Magisk作者修复，并删除本模块！" >$Module_XinXi

printf "id=$MODID
name=$name
version=$version
versionCode=$versionCode
author=$author
description=$description" >$Module_XinXi.bak

! $RUN_THE_RECORD && sed -i '/RUN_THE_RECORD=/c RUN_THE_RECORD=/dev/null' $fun
stat -c "%z" $ENV_FILE >/dev/null || sed -i '/stat -c/d' $fun
[[ ! -f $jian4 ]] && sed -ri '/\/Han\/4.sh|\/Han\/k4.sh/d' $Module_S2 && sed -i '2d' $jian1
[[ `wc -l <$jian3a` = 7 ]] && sed -i '/\/Han\/3a.sh/d' $Module_S2 && rm -f $jian3a

echo -e "\n- 设置权限……"
set_perm_recursive "$Module" 0 0 0700 0700
[[ -f $Module_XinXi ]] && echo "- 「$name」模块已创建模块，重启手机后生效！"
echo
echo "- 查看「$name」模块描述："
echo "$description"
$CQ
