#本脚本由　by Han | 情非得已c，编写
#应用于搞机客上


Disable_All_Modules() {
    local IFS=$'\n'
    ls $Modules_Dir | while read m; do
        [[ -e "$Modules_Dir/$m/disable" ]] && rm -rf "$Modules_Dir/$m/disable"
        touch "$Modules_Dir/$m/disable" >/dev/null
    done
        toast "- 已禁用了所有模块。"
}

Enable_All_Modules() {
    local IFS=$'\n'
    ls $Modules_Dir | while read m; do
        rm -rf "$Modules_Dir/$m/"{disable,remove,skip_mount} >/dev/null
    done
        toast "- 已启用了所有模块。"
}

if [[ $1 = -summary ]]; then
    mask -m "$2"
    if [[ -e $Module_Disable ]]; then
        echo "- 模块将在下次重启后禁用"
    fi
    if [[ -e $Module_Remove ]]; then
        echo "- 模块将在下次重启后卸载"
    fi
    if [[ -e $Module_Update ]]; then
        echo "- 已更新了模块但尚未重启"
    fi
    if [[ -e $Module_Skip_Mount ]]; then
        echo "- 模块将在下次重启后，不对system文件夹进行更改"
    fi
elif [[ $1 = -desc ]]; then
    sed -n -e "s#^id=#模块路径：$Modules_Dir/#p" -e 's/^version=/版本：/p' -e 's/^versionCode=/版本号：/p' -e s'/^author=/作者：/p' -e 's/^description=//p' "$Modules_Dir/$2/module.prop"
elif [[ $1 = -g ]]; then
    mask -m "$2"
    if [[ -e $Module_Disable ]]; then
        echo d
    elif [[ -e $Module_Remove ]]; then
        echo r
    elif [[ -e $Module_Skip_Mount ]]; then
        echo s
    else
        echo e
    fi
elif [[ $1 = -da ]]; then
    Disable_All_Modules
elif [[ $1 = -ea ]]; then
    Enable_All_Modules
else
    mask -m "$1"
    case $STATE in
        e)
            rm -rf "$Module_Remove" "$Module_Disable" "$Module_Skip_Mount" &>/dev/null
        ;;
        
        d)
            rm -rf "$Module_Remove"
            touch "$Module_Disable"
        ;;
        
        r)
            touch "$Module_Remove"
        ;;
        
        s)
            touch "$Module_Skip_Mount"
        ;;
    esac
fi