#本脚本由　by Han | 情非得已c，编写
#应用于搞机客上


mod() {
    unset id name version versionCode author description
    unzip -p "$file" module.prop | sed -r 's/`|\$\(//g; s/"/\\"/g; s/\\/\\\\\\/g' | sed -n '/^id=/p; /^name=/p; /^version=/p; /^versionCode=/p; /^author=/p; /^description=/p' | sed 's/^id=/&"/; s/^name=/&"/; s/^version=/&"/; s/^versionCode=/&"/; s/^author=/&"/; s/^description=/&"/; s/$/"/g'
}


tmp=$TMPDIR/modules.ini
file_name=magisk_modules-local.json
json=$PAGE/$file_name
version=13
log="$CONFIG_DIR/magisk_Modules-Local.log"
log2="$CONFIG_DIR/magisk_Modules-Local_Dir.log"
[[ -f $log ]] && user_version=`cat $log` || user_version=0


    if [[ $1 = -lu ]]; then
cat <<Han | sed 's/"/\\"/g' >$log2
${LU}
Han
        echo "正在重新搜索，请骚等……"
    elif [[ $1 = -s ]]; then
        echo "正在刷新页面信息状态，请骚等……"
    elif [[ $user_version -lt $version ]]; then
        echo $version >$log
    elif [[ ! -f $json ]]; then
        :
    elif [[ -f $json ]]; then
        exit 0
    fi

mkch -r $TMPDIR
Start_Time
if [[ -f $log2 ]]; then
    find "`cat $log2`" -type f -name '*.zip' >$tmp
    SD_DIR="`cat $log2`"
else
    find "$SD_DIR" -type f -name '*.zip' >$tmp
fi
    exec 3>&1
    exec >$json


cat <<Han
[
    {
        "TextList": {
            "title": "当前已搜索到HHH个模块，最后搜索于：`date '+%F %H:%M:%S'`"
        }
    },
    {
        "All in one": {
            "meta": {
                "autoExit": true,
                "reload": true
            },
            "title": "自定义模块搜索目录",
            "summary": "当前搜索目录：$SD_DIR",
            "params": [
                {
                    "name": "LU",
                    "title": "可输入目录绝对路径，也可以通过文件选择器长按选定目录",
                    "desc": "上面是默认路径，请自行根据需求更改目录，温馨提示：可用「MT管理器」长按目录或文件 -->点属性 -->点击目录即可复制目录绝对路径，长按目录或长按名称即可复制文件绝对路径",
                    "type": "folder"
                }
            ],
            "shell": ". ./magisk_module/search_magisk_modules-local.sh -lu"
        }
    },
    {
        "Run": {
            "meta": {
                "autoExit": true,
                "reload": true
            },
            "title": "重新搜索模块",
            "summary": "清除已缓存的搜索结果，重新搜索模块",
            "shell": ". ./magisk_module/search_magisk_modules-local.sh -s"
        }
    },
Han


num=0
while read -r file; do
if ! unzip -p "$file" 'META-INF/com/google/android/updater-script' 2>/dev/null | fgrep -q '#MAGISK' ; then
    continue
else
    ((++num))
    File_Name=`basename "$file"`
    File_Dir=`dirname "$file"`
    last_update0=`stat -c '%Y' "$file"`
    last_update=`date -d @$last_update0 '+%F %H:%M:%S'`
    eval `mod`
    if [[ -n "$id" ]]; then
        desc="模块id：$id\n名称：$name\n版本：$version\n版本号：$versionCode\n作者：$author\n描述：$description\n修改时间：$last_update\n文件路径：$file"
    else
        desc="修改时间：$last_update\n文件路径：$file"
    fi

cat <<Han
    {
        "All in one": {
            "title": "$File_Name",
            "desc": "$desc",
            "params": [
                {
                    "name": "option",
                    "title": "请选择功能",
                    "type": "Spinner",
                    "options": [
                        "az|①　安装",
                        "r|②　删除",
                        "tz|③　跳转文件目录"
                    ],
                    "required": true
                },
                {
                    "name": "ChongQi",
                    "label": "是否刷入成功自动重启系统生效",
                    "type": "switch"
                },
                {
                    "name": "Error",
                    "label": "不显示模块里的错误信息",
                    "desc": "注释：该错误信息log来自模块里，关闭状态时会显示完整日志等于Magisk的保存日志功能。",
                    "type": "switch",
                    "value": true
                },
                {
                    "name": "Compatible",
                    "label": "使用兼容模式（兼容旧模块）",
                    "desc": "注：该「兼容模式」需要模块作者遵守Magisk Modules开发指南规定，不更改update-binary脚本",
                    "type": "switch"
                },
                {
                    "name": "File_Dir",
                    "type":"text",
                    "value": "模块目录：$File_Dir"
                },
                {
                    "name": "Download_File",
                    "type":"text",
                    "value": "模块路径：$file"
                }
            ],
            "shell": ". ./magisk_module/search_magisk_modules-ldw.sh"
        }
    },
Han
    unset id name version versionCode author description last_update0 last_update File_Name File_Dir
fi
done < $tmp

exec 1>&3
exec 3>&-

sed -i "4 s/搜索到HHH个模块/搜索到$num个模块/" $json
rm -f $tmp
End_Time -t 刷新 &>/dev/null

if [[ $num = 0 ]]; then
    sed -i '7,$d' $json
    error "！未从本地搜索到Magisk模块"
fi
sed -i  '$ s/,$//' $json
echo ']' >>$json
fjson -c $json
