#本脚本由　by Han | 情非得已c，编写
#应用于搞机客上


var(){
    echo "$line" | sed "s/^$1=//g"
}

XML() {
    fgrep 'string name' "$xml" | sed 's/&quot;/"/g; s/\\\//\//g; s/","/\n/g; s/":"/="/g' | sed 's/$/"/g' | sed -n '/^md5=/p; s/^name=/\n\n\n\n\n\nname=/gp; /^version=/p; /^codebase=/p; /^filename=/p; /^filesize=/p'
    echo
}

Check_md5() {
cat <<Han
    {
        "Div": {
            "size": 22.5,
            "value": "校验md5",
            "color": "#FF18BCF8"
        }
    },
    {
        "All in one": {
            "title": "校验已下载的ROM文件md5",
            "summary": "验证ROM包是否下载完整，防止卡刷时报错",
            "shell": ". ./check_miui_rom_md5.sh",
            "params": [
                {
                    "name": "MD5",
                    "type":"EditText",
                    "title": "输入md5效验，也可以留空选择文件校验"
                },
                {
                    "name": "File",
                    "type": "file",
                    "required": true,
                    "title": "可输入已下载ROM文件绝对路径，也可以使用文件选择器选择文件",
                    "desc": "温馨提示：可用「MT管理器」长按目录或文件 -->点属性 -->点击目录即可复制目录绝对路径，长按目录或长按名称即可复制文件绝对路径"
                }
            ]
        }
    },
Han
}


c=false
xml=$USER_DIR/com.android.updater/shared_prefs/version_json.xml



if [[ ! -f $xml ]]; then
cat <<Han
[
    {
        "Texts": {
            "params": [
                {
                    "size": 35,
                    "color": "#FFFF0000",
                    "value": "未找到版本信息，请检查是否已屏蔽/冻结「系统更新」"
                }
            ]
        }
    }
]
Han
exit 1
else
    device=$(getprop ro.product.device)
    model=$(getprop ro.product.marketname)
cat <<Han
[
    {
        "Texts": {
            "params": [
                {
                    "size": 35,
                    "color": "#FF9C27B0",
                    "value": "$model（$device）ROM下载地址获取"
                }
            ]
        }
    },
Han
fi



MD5=$(XML | grep '^md5=' | sort -u)
if [[ -n "$MD5" ]]; then
Check_md5

for i in $MD5; do
    md5_now=$(XML | sed -n "/$i/=" | head -n 1)
    start=$((md5_now-6))
    end=$((md5_now+6))
    eval $(XML | sed -n "$start,${end}p")
    LINK="\$Source_url/$version/$filename"
    if [[ "$version" = V* ]]; then
        BanBen=稳定版
    else
        BanBen=开发版
    fi
        if [[ "$name" = *OTA\ From* || $filename = *-blockota-* ]]; then
            Bao=增量包
        else
            Bao=完整包
        fi




cat <<Han
    {
        "Div": {
            "size": 22.5,
            "value": "$BanBen",
            "color": "#FF18BCF8"
        }
    },
    {
        "All in one": {
            "title": "$version $Bao",
            "desc": "点即可跳转浏览器下载\n",
            "summary": "安卓：${codebase}\n大小：${filesize}\nMD5：${md5}",
            "shell": "if [[ \$Option = copy ]]; then echo $LINK ; elif [[ \$Option = download ]]; then Web $LINK; fi",
            "params": [
                {
                    "name": "Source_url",
                    "title": "来源接口",
                    "type": "Spinner",
                    "options": [
                        "https://hugeota.d.miui.com|①",
                        "https://bigota.d.miui.com|②"
                    ]
                },
                {
                    "name": "Option",
                    "title": "选择类型",
                    "type": "Spinner",
                    "options": [
                        "copy|打印链接",
                        "download|跳转浏览器下载"
                    ]
                }
            ]
        }
    },
Han
done | sed '$ s/,$//g'
echo ']'
fi
