#本脚本由　by Han | 情非得已c，编写
#应用于搞机客上


Disable_All_Modules() {
    local IFS=$'\n'
    for i in /data/adb/modules /data/adb/lite_modules; do
        [[ -d $i ]] && ls $i | while read m; do
            [[ -e "$i/$m/disable" ]] && rm -rf "$i/$m/disable"
            touch "$i/$m/disable" >/dev/null
        done
    done
}

Enable_All_Modules() {
    local IFS=$'\n'
    for i in /data/adb/modules /data/adb/lite_modules; do
        [[ -d $i ]] && ls $i | while read m; do
            rm -rf "$i/$m/"{disable,remove,skip_mount} >/dev/null
        done
    done
    echo 已禁用除「神仙自动救砖」外所有模块，并重启手机
    reboot
}



if [[ $1 = -s ]]; then
    shift
    mask -m $1
    if [[ -f $Module_Disable ]]; then
        echo "- 模块将在下次重启后禁用"
    fi
    if [[ -f $Module_Remove ]]; then
        echo "- 模块将在下次重启后卸载"
    fi
    if [[ -f $Module_Update ]]; then
        echo "- 已更新了模块但尚未重启"
    fi
    if [[ -f $Module_Skip_Mount ]]; then
        echo "- 模块将在下次重启后，不对system文件夹进行更改"
    fi
    exit 0
elif [[ $1 = -g ]]; then
    shift
    mask -m $1
    if [[ -f $Module_Disable ]]; then
        echo d
    elif [[ -f $Module_Remove ]]; then
        echo r
    elif [[ -f $Module_Skip_Mount ]]; then
        echo s
    else
        echo e
    fi
    exit 0
elif [[ $1 = -d ]]; then
    Disable_All_Modules
    echo "- 已禁用了所有模块，可在右上角刷新界面或返回重进才能刷新当前页面状态"
elif [[ $1 = -e ]]; then
    Enable_All_Modules
    echo "- 已启用了所有模块，可在右上角刷新界面或返回重进才能刷新当前页面状态"
fi

mask -m "$1"

case $STATE in
    e)
        rm -rf "$Module_Remove" "$Module_Disable" "$Module_Skip_Mount" &>/dev/null
    ;;
    
    d)
        rm -rf "$Module_Remove"
        touch "$Module_Disable"
    ;;
    
    r)
        touch "$Module_Remove"
    ;;
    
    s)
        touch "$Module_Skip_Mount"
    ;;
esac
