#本脚本由　by Han | 情非得已c，编写
#应用于搞机客上


start_xml() {
cat <<Han >$f
[
    {
        "Texts": {
            "params": [
                {
                    "size": 36,
                    "color": "#FFFF0000",
                    "value": "$slice1",
                    "br": 2
                },
                {
                    "size": 32,
                    "color": "#FF9C27B0",
                    "value": "$slice2",
                    "br": 2
                },
                {
                    "size": 32,
                    "color": "#FF9C27B0",
                    "value": "免责申明：\n一旦使用了本页任何功能，出现的一切后果与我无关！请自行承担风险"
                }
            ]
        }
    },
Han
if [[ $cs1 = -gmm || $cs1 = -github ]]; then
local conf=$GJZS/$xml_name.conf
cat <<Han >>$f
    {
        "Run": {
            "meta": {
                "autoExit": true,
                "interruptible": true,
                "reload": true
            },
            "title": "刷新页面信息",
            "summary": "清除已缓存的仓库数据，$s（本功能未加自动更新功能，如果需要加载最新数据请在此刷新即可，请不要恶意频繁刷新否则会触发Github的滥用机制）",
            "shell": ". ./$_script -s"
        }
    },
    {
        "All in one": {
            "meta": {
                "autoExit": true
            },
            "title": "修改配置文件",
            "desc": "这是一个可自定义的功能，请在此修改您的专属配置文件，因为默认我只加了$example个事例链接",
            "shell": ". ./$_script -c",
            "params": [
                {
                    "name": "Way",
                    "title": "功能",
                    "type":"Spinner",
                    "options": [
                        "0|①　修改",
                        "d|②　恢复默认"
                    ]
                },
                {
                    "name": "config",
                    "type":"EditText",
                    "title": "已可以用其它软件更改：$conf",
                    "value-sh": "cat $conf"
                }
            ]
        }
    },
Han
else
cat <<Han >>$f
    {
        "Run": {
            "meta": {
                "autoExit": true,
                "interruptible": true,
                "reload": true
            },
            "title": "刷新页面信息",
            "summary": "清除已缓存的仓库数据，刷新$title变动过后的数据",
            "shell": ". ./$_script -s"
        }
    },
Han
fi
}

title() {
let num++
Serial_number
cat <<Han >$f
    {
        "Div": {
            "size": 22.5,
            "value": "$1",
            "color": "#FFFF0000"
        }
    },
Han
}

Serial_number() {
    f=$dir/`printf "%0${len}s" $num`
}

Inject() {
    $ml -s -o "$2" "${LINK/\%s/$1}"
}

SCRIPT() {
    [[ $# -ne 4 ]] && return 1
    if [[ `md5sum2 $2 2>/dev/null` = "$3" ]]; then
        return 0
    fi
        Inject $1 $2
        if [[ `md5sum2 $2` = "$3" ]]; then
            echo "- 加载$4成功"
            updated__At=true
        else
            rm -f $2
            abort "- 加载$4失败"
        fi
}

the_end() {
    cat $dir/* | tr -d '\n' >$json
    sed -ri 's/\\\\\\/\\\\/g; s/,( {20}\] {16}\},)/\1/g; s/,$//' $json
    echo ']' >>$json
    fjson -c $json
    End_Time -t $a $data_name
    echo "- 正在加载页面……"
    mkch -r $TMPDIR
}

_apk() {
echo "- 检测是否有已安装app……"
appinfo -o pn -a >$TMPDIR/apk_name.log

for i in ${MOD_ID[@]}; do
    let H++
    if fgrep -qx "$i" $TMPDIR/apk_name.log; then
        unset user_versionCode versionCode
        install[$H]=$i
        user_versionCode=`show_versionCode $i`
        . "$data" "$i"
        [[ "$user_versionCode" -lt "$versionCode" ]] && update[$H]=$i && unset install[$H]
    else
        noinstall[$H]=$i
    fi
done
}

_id() {
echo "- 检测是否有已安装Magisk模块……"
for i in ${MOD_ID[@]}; do
    let H++
    if [[ -d $Modules_Dir/$i ]]; then
        unset versionCode0 versionCode
        install[$H]=$i
        mask -m "$i"
        . "$data" "$i"
        [[ $versionCode0 -lt $versionCode ]] && update[$H]=$i && unset install[$H]
    else
        noinstall[$H]=$i
    fi
done
}

Sort_method() {
    local flie=$CONFIG_DIR/$xml_name-sort.log
    case $STATE in
        1 | jisu)
            . menu_fun.sh
        ;;
        
        ctime | ctime-n)
            echo "- 已恢复默认的按更新时间排序"
            rm -rf $flie
        ;;&
        
        name | name-n)
            echo "- 已选择按名称排序"
            touch $flie
        ;;&
        
        ctime-n | name-n)
            unset STATE
            . $SCRIPT/$_script -sn
        ;;
        
        ctime | name | refresh)
            unset STATE
            . $SCRIPT/$_script -s
        ;;
    esac
}

create_jid() {
    for c in `seq "$Number_of_threads"`;do echo $c >&6; done
}

wait_jid() {
    # wait
    echo "- 等待 $* 列表处理完毕……"
    for w in `seq $Number_of_threads`; do read -u6; done
    Serial_number
}





cs1=$1
updated__At=false
[[ -x $ELF2_PATH/curl ]] && ml='curl --connect-timeout 8' || ml="down -m 8"
. $data_MD5
case "$cs1" in
    -gmm)
        title=Magisk模块
        xml_name=github_magisk_modules
        md5=None
        data_name="$title仓库"
        example=4
        s="刷新$title变动过后的数据，"
    ;;&
    
    -github)
        title='Github-Releases'
        xml_name=github_releases
        md5=None
        data_name="$title(发布文件)"
        example=2
        s=
    ;;&
    
    -mmro)
        title=Magisk模块
        xml_name=magisk_modules_repo_official
        md5=$MMROD_MD5
        data_name='Magisk Modules Repo (Official)'
    ;;&
    
    -mmar)
        title=Magisk模块
        xml_name=magisk_modules_alt_repo
        md5=$MMARD_MD5
        data_name='Magisk-Modules-Alt-Repo'
    ;;&
    
    -mw)
        title=Magisk模块
        xml_name=magisk_warehouse
        md5=$MWD_MD5
        data_name="$title仓库"
    ;;&
    
    -app_store)
        title='应用/Xposed模块'
        xml_name=app_store
        _script="$xml_name-page.sh"
        md5=$ASD_MD5
        data_name="$title仓库"
        data=$SCRIPT/$xml_name-data.sh
    ;;&
    
    -xp)
        unset -f Inject
        Inject() {
            $ml -s -o "$2.gz" "${LINK/\%s/$1.gz}"
            gunzip -f "$2.gz"
        }
        
        xml_name=xposed_module_repository
        md5=$XMRD_MD5
        data_name='Xposed Module Repository'
    ;;&
    
    -lsp)
        xml_name=lsposed_module_repository
        md5=$LMRD_MD5
        data_name='LSPosed Module Repository'
    ;;&
    
    -mmro | -mw | -gmm | -mmar)
        _script="magisk_module/$xml_name-page.sh"
        data=$SCRIPT/magisk_module/$xml_name-data.sh
    ;;&

    -lsp | -xp | -github)
        data=$SCRIPT/$xml_name-data.sh
        _script=$xml_name-page.sh
    ;;&
    
    -lsp | -xp)
        title=XP模块
    ;;&
    
    *)
        init_data_ID=$xml_name-data.sh
        Timestamp=`grep_prop Timestamp $data`
    ;;
esac

    if [[ -z $md5 ]]; then
        unset MOD_ID
        args=-s
    else
        if [[ $cs1 = -gmm ]]; then
            [[ ! -f $data ]] && . ./magisk_module/github_magisk_modules.sh
        elif [[ $cs1 = -github ]]; then
            [[ ! -f $data ]] && . ./$xml_name.sh
        else
            SCRIPT "$init_data_ID" $data $md5 "$data_name"
        fi
        Sort_method
        case "$cs1" in
            -xp | -lsp | -app_store)
                check=_apk
            ;;
            
            -mmro | -mw | -mmar)
                check=_id
            ;;
            
            -github | -gmm)
                check=':'
            ;;
        esac
        [[ -f $flie ]] && . $data -name || . $data -time
    fi


file_name=$xml_name.json
json="$PAGE/$file_name"
dir=$TMPDIR/json
FIFO="$TMPDIR/$$"
H=0
num=0

mod_num=${#MOD_ID[@]}
len=${#mod_num}
Number_of_threads=10

if [[ $args = -s ]]; then
    a='刷新'
elif [[ ! -f $json ]]; then
    a='初始化'
elif $updated__At; then
    a='更新'
else
    exit 0
fi

    echo "- 正在$a $data_name 仓库……"
    Start_Time
    mkch -r $TMPDIR
    mkch $dir
    case "$cs1" in
        -mmro)
            slice1="当前 Magisk 官方已上架了$mod_num个模块"
            slice2="本页所有Magisk模块均为 @John Wu 自建的仓库，因为即将在新版本中移除所以特意保留此仓库，与人方便"
        ;;
        
        -mmar)
            slice1="当前 Magisk-Modules-Alt-Repo 已上架了$mod_num个模块"
            slice2="本页所有Magisk模块均来自 Magisk-Modules-Alt-Repo 仓库"
        ;;
        
        -lsp)
            slice1="当前 LSPosed 已上架$mod_num个XP模块"
            slice2="本页所有模块均为 @LSPosed Developers 自建的模块仓库"
        ;;
        
        -xp)
            slice1="当前 Xposed 已上架$mod_num个模块"
            slice2="本页所有模块均为 @rovo89 自建模块仓库"
        ;;
        
        -app_store)
            slice1="已上架了$mod_num个应用"
            slice2="本功能由 @by：Han | 情非得已c 收集的一些其它常规应用商店没有的应用，如果你有好的应用想分享，或者你是应用作者，可发送邮件我云端上架分享大家一起享用"
        ;;
        
        -mw)
            slice1="已上架了$mod_num个Magisk模块"
            slice2="本功能由 @by：Han | 情非得已c 自作/收集的一些Magisk模块，如果你有好的模块想分享，或者你是模块作者，可发送邮件我云端上架分享大家一起享用"
        ;;
        
        -gmm)
            slice1="已加载了$mod_num个Magisk模块"
            slice2="本功能可自定义Github源，然后每次刷新时联网获取最新的Releases(发布)文件，由 @by：Han | 情非得已c 提供技术服务"
        ;;
        
        -gmm | -github)
            slice1="已加载了$mod_num个Releases"
            slice2="本功能可自定义Github源，然后每次刷新时联网获取最新的Releases(发布)文件，由 @by：Han | 情非得已c 提供技术服务"
        ;;
    esac
    slice1="$slice1，最后更新于：$Timestamp"
    
    Serial_number
    start_xml
    if [[ "$mod_num" -eq 0 ]]; then
        title "$a $data_name 失败！"
        toast MOD_ID 为空！
        Serial_number
        the_end
        exit 1
    fi



$check
echo "- 正在生成json页面数据……"
mkfifo "$FIFO"
exec 6<>"$FIFO"

if [[ $cs1 = -github || $cs1 = -gmm ]]; then
    if [[ -n ${MOD_ID[@]} ]]; then
        create_jid
        title "Latest release（${#MOD_ID[@]}）"
        for p in ${MOD_ID[@]}; do
            read -u6
            let num++
            p "$p" &
        done
        wait_jid $data_name
    fi
else
    if [[ -n ${update[@]} ]]; then
        create_jid
        title "有更新（${#update[@]}）"
        for i in ${update[@]}; do
            read -u6
            let num++
            p "$i" -y &
        done
        wait_jid 有更新
    fi
        if [[ -n ${install[@]} ]]; then
            create_jid
            title "已安装（${#install[@]}）"
            for o in ${install[@]}; do
                read -u6
                let num++
                p "$o" -y &
            done
            wait_jid 已安装
        fi
            if [[ -n ${noinstall[@]} ]]; then
                create_jid
                title "未安装（${#noinstall[@]}）"
                for p in ${noinstall[@]}; do
                    read -u6
                    let num++
                    p "$p" &
                done
                wait_jid 未安装
            fi
fi
                exec 6>&-
                exec 6<&-
                the_end
