#本脚本由　by Han | 情非得已c，编写
#应用于搞机客上


version=17
. $SCRIPT/switch_ab_partition.sh -c &>/dev/null
[[ $? -eq 0 ]] && jian="$CONFIG_DIR/by_name$SLOT.log" || jian="$CONFIG_DIR/by_name.log"
log="$CONFIG_DIR/Block_Device_version.log"
[[ -f $log ]] && user_version=`cat $log` || user_version=0

if [[ $user_version -lt $version || ! -f $jian ]]; then
    toast 正在加载分区列表……
    rm -rf $jian &>/dev/null
    for i in sort basename find grep sed; do
        which $i &>/dev/null || { toast "$i 命令未找到"; exit 1; }
    done
    
    BC=`which bc`
    BLOCKDEV=`which blockdev`
    num=6
    echo $version >$log
    mkch -r $TMPDIR
    cd $TMPDIR
    find /dev/block/ -maxdepth 1 -type b -exec basename {} \; | sort >b.ini
    find /dev/block/ \( -path /dev/block/mapper/by-uuid -o -path /dev/block/bootdevice \) -prune -o -type l -exec basename {} \; | sort -u >l.ini
    find /dev/block/ -type l >path.ini
        while read line; do
            fgrep -qx "$line" b.ini || echo "$line" >>name.ini
        done < l.ini
            while read o; do
                unset link
                link=`egrep -m 1 "/$o\$" path.ini`
                [[ ! -b `readlink $link` ]] && continue
                    if [[ -n "$BC" && -n $BLOCKDEV ]]; then   
                        size=`"$BLOCKDEV" --getsize64 $link`
                        if [[ $size -ge 1073741824 ]]; then
                            File_Type=`echo "scale=$num; $size/1073741824" | "$BC"`G
                        elif [[ $size -ge 1048576 ]]; then
                            File_Type=`echo "scale=$num; $size/1048576" | "$BC"`MB
                        elif [[ $size -ge 1024 ]]; then
                            File_Type=`echo "scale=$num; $size/1024" | "$BC"`kb
                        elif [[ $size -lt 1024 ]]; then
                            File_Type=${size}b
                        fi
                            echo "$link|$o 「大小：$File_Type」" >>$jian
                    else
                        echo "$link|$o" >>$jian
                    fi
            done < name.ini
            rm -rf $TMPDIR
            cd - >/dev/null
            sed -i -re 's/\.0{2,6}kb/kb/g' -re 's/\.0{2,6}MB/MB/g' -re 's/\.0{2,6}G/G/g' $jian
            toast 分区列表加载完成
fi

cat $jian
