#本脚本由　by Han | 情非得已c，编写
#应用于搞机客上


[[ ! -f "$File" ]] && abort "！$File文件不存在无法查看md5"


_hash() {
    $1 "$File" | sed 's/ .*//g'
}

if [[ -n $value ]]; then
    echo "- 当前输入的哈希值为：$value"
    ml="tee $Status"
else
    ml='cat -'
fi

echo -e "- 正在计算中……\n"
for i in $Hash; do
    echo -n "`sed -n "s/$i|//p" ./check_hash_options.sh`="
    case $i in
        sha1sum | sha224sum | sha256sum | sha384sum | sha3sum | sha512sum)
            _hash $i
        ;;
        
        crc32 | md5sum2)
            $i "$File"
        ;;
    esac
    echo
done | $ml

if [[ -n $value ]]; then
    a=`sed -rn "/=$value$/s/(.*)=$value/- 输入的哈希值校验成功，结果为：\1/p" $Status`
    [[ -n $a ]] && echo "$a" || abort "！ 输入的哈希值未找到"
fi
