#本脚本由　by Han | 情非得已c，编写
#应用于搞机客上
#$1定义是否使用兼容模式
#$2定义屏蔽错误显示
#$3定义文件
#$4定义是否下载
#$5定义传给配置文件的$1变量


dummy() {
    install_zip "$ZIPFILE"
    if $Error; then
        exec 2>&3
        exec 3>&-
    fi
}

end() {
    result=$?
    echo "THE END"
    rm -rf $TMPDIR &>/dev/null
    CQ
    exit $result
}


[[ $# -lt 4 ]] && abort "！参数错误❌，error：$#"

Compatible="$1"
Error="$2"
ZIPFILE="$3"
Choice="$4"
Download_ID="$5"
A=false
INSTALLER=$TMPDIR
AUTOMOUNT=false
SKIPMOUNT=false
PROPFILE=false
POSTFSDATA=false
LATESTARTSERVICE=false
PERSISTDIR=$Frame_Dir/persist

if $Choice; then
    resources=~/resources/magisk_warehouse
    id="$Download_ID"
    . $MWD $Download_ID
    ZIPFILE="$Download_File"
fi
    M=${ZIPFILE##*/}
    [[ ! -f "$ZIPFILE" ]] && abort "！$ZIPFILE 文件不存在无法刷入"
    unzip -p "$ZIPFILE" 'META-INF/com/google/android/updater-script' | fgrep '#MAGISK' &>/dev/null || abort "「$M」不是Magisk模块.zip！无法刷入"
    
    if $Error; then
        exec 3>&2
        exec 2>/dev/null
    fi
        if $Compatible; then
            echo "- 正在已「兼容模式」安装「$M」……"
            . $SCRIPT/geek/util_functions.sh
            mkch -r "$TMPDIR"
            unzip -oq "$ZIPFILE" "module.prop" -d $TMPDIR
                if [[ -f $TMPDIR/module.prop ]]; then
                    MODDIRNAME=$PACKAGE_NAME
                    MODULEROOT=${Frame_Dir}_update
                    MODID=`grep_prop id $TMPDIR/module.prop`
                    [[ -z $MODID ]] && abort "！该模块未提供id属性"
                    MODNAME=`grep_prop name $TMPDIR/module.prop`
                    MODAUTH=`grep_prop author $TMPDIR/module.prop`
                    MODPATH="$MODULEROOT/$MODID"
                    MODPATH0="$Frame_Dir/$MODID"
                    echo "- 模块被安装在：$MODPATH0"
                    echo "- 模块名称：$MODNAME"
                    echo "- 模块作者：$MODAUTH"
                else
                    echo -e "\n！温馨提示：「$M 」未找到module.prop文件\n---------------------------------------------------------\n\n"
                fi
                    mkch -n -r $MODPATH $MODPATH0 
            
            Installation_script() {
                unzip -l "$ZIPFILE" $1 | grep -q $1
                return $?
            }
            
            print_modname() {
              ui_print "*************************"
              ui_print "- Powered by $author"
              ui_print "*************************"
            }
            
            
            mount_partitions
            api_level_arch_detect
            
            [[ -n $MODNAME ]] && echo "- - 正在安装「$MODNAME」"
            if Installation_script install.sh; then
                A=true
                echo "- 开始解压install.sh安装脚本"
                unzip -ojq "$ZIPFILE" install.sh uninstall.sh 'common/*' -d $TMPDIR &>/dev/null
            elif Installation_script config.sh; then
                A=true
                echo "- 开始解压config.sh安装脚本"
                unzip -oq "$ZIPFILE" config.sh uninstall.sh 'common/*' -d $TMPDIR &>/dev/null
                unzip -oq "$ZIPFILE" 'system/*' -d $MODPATH  &>/dev/null
                [[ -f $TMPDIR/config.sh ]] && mv -f $TMPDIR/config.sh $TMPDIR/install.sh
                [[ -n `ls $TMPDIR/common` ]] && mv -f $TMPDIR/common/* $TMPDIR
            fi
                    if $A; then
                         . $TMPDIR/install.sh
                         
                         print_modname
                         on_install
                         
                         [ -f $TMPDIR/uninstall.sh ] && cp -af $TMPDIR/uninstall.sh $MODPATH/uninstall.sh
                         { $AUTOMOUNT && touch $MODPATH/auto_mount; } || { $SKIPMOUNT && touch $MODPATH/skip_mount; }
                         $PROPFILE && cp -af $TMPDIR/system.prop $MODPATH/system.prop
                         cp -af $TMPDIR/module.prop $MODPATH/module.prop
                         $POSTFSDATA && cp -af $TMPDIR/post-fs-data.sh $MODPATH/post-fs-data.sh
                         $LATESTARTSERVICE && cp -af $TMPDIR/service.sh $MODPATH/service.sh
                         
                         ui_print "- 开始设置权限"
                         set_permissions
                         
                    elif Installation_script customize.sh; then
                        print_modname
                        echo "- 开始解压customize.sh安装脚本"
                        unzip -oq "$ZIPFILE" customize.sh -d $MODPATH &>/dev/null
            
                            if ! egrep -q '^SKIPUNZIP=1$' $MODPATH/customize.sh 2>/dev/null; then
                                ui_print "- 提取模块文件"
                                unzip -oq "$ZIPFILE" -x 'META-INF/*' -d $MODPATH &>/dev/null
                            fi
                        [[ -f $MODPATH/customize.sh ]] && . $MODPATH/customize.sh
                    else
                        echo "- 未找到安装脚本，已自动关闭兼容模式开始安装"
                        dummy
                        end
                    fi
            
                            [[ -n "$REPLACE" ]] && error "！不支持REPLACE功能"
            
                                if [[ -f $MODPATH/sepolicy.rule ]]; then
                                    ui_print "- 安装自定义Sepolicy补丁"
                                    copy_sepolicy_rules
                                fi
            [[ -z $MODPATH ]] && exit 1
            rm -rf \
            $MODPATH/system/placeholder $MODPATH/customize.sh \
            $MODPATH/README.md $MODPATH/.git* $TMPDIR &>/dev/null
            rmdir -p $MODPATH
            [[ ! -d $MODPATH ]] && abort "！安装$MODNAME失败"
            mv -f $MODULEROOT/* $Frame_Dir
            rm -rf $MODULEROOT
            ui_print -e "\n- $MODNAME模块安装完成。"
            end
        else
            dummy
            end
        fi
