#本脚本由　by Han | 情非得已c，编写
#特别鸣谢：1群里的by 依心所言提供思路
#应用于搞机客上


abort() {
    echo "$@" 1>&2
    sleep 3
    echo 1 >$Status
    exit 1
}


IFS=$'\n'
TMP=/data/local/tmp
suffix=${File##*.}
name=`basename "$File"`
[[ $1 = -s ]] && installer=" -i $installer " || installer=" "
[[ -z $Delete_APK ]] && Delete_APK=false

#com.android.vending

echo "- 开始安装$name……"
echo 0 >$Status
if [[ ! -f $File ]]; then
    abort "！ 文件不存在无法安装"
else
    unzip2 -cf "$File" &>/dev/null
    [[ $? -ne 0 ]] && abort "！$name 不是压缩文件"
fi


if [[ $suffix = apk ]]; then
    size=`wc -c < "$File"`
    a="cat \""$File"\" | pm install -r -t -S "$size""$installer" 1>/dev/null"
    eval $a
    result=$?
    if [[ $result = 0 ]]; then
        $Delete_APK && rm -f "$File"
        echo 0 >$Status
        echo "- $name安装成功"
        # else
        # echo "！启用B计划安装"
        # cp -f "$File" $TMP
        # a="pm install -r -t"$installer"\""$TMP/$name"\" 1>/dev/null"
        # eval $a
        # result=$?
        # rm -f "$TMP/$name"
    else
        abort "！安装失败"
    fi
    sleep 3
    exit $result
elif [[ $suffix = apex ]]; then
    size=`wc -c < "$File"`
    a="cat \""$File"\" | pm install -r -t -S "$size" --apex"$installer" 1>/dev/null"
    eval $a
    result=$?
    [[ $result = 0 ]] && echo "- $name安装成功" && $Delete_APK && rm -f "$File" || abort "！$name安装失败."
    sleep 3
    exit $result
fi


if unzip -l "$File" | fgrep -q 'Android/obb'; then
    echo "- 开始解压obb资源……"
    unzip -o "$File" 'Android/*' -d "$SD_DIR" 1>/dev/null
    [[ $? = 0 ]] && echo "- ${name}obb资源解压成功" || abort "！${name}obb资源解压失败"
fi

Number=`unzip -l "$File" 2>/dev/nul | egrep '\.apk'$ | wc -l`
[[ $Number -eq 0 ]] && abort "！$name 文件不是正规$suffix文件"
session1="pm install-create -r"$installer""
session=`eval $session1`
echo $session | grep -iq 'Success' || abort "！安装$name失败"
session_id=$(echo $session | sed -n 's/.*\[\(.*\)\]/\1/p')
Piping_file="$TMPDIR/FIFO"
mkch -r $TMPDIR
Number_of_threads=10

echo - 启用$Number_of_threads个多线程处理
mkfifo "$Piping_file"
exec 6<>"$Piping_file"
rm -f "$Piping_file"
for o in `seq "$Number_of_threads"`; do
    echo
done >&6

echo "- 已检测到有$Number个被分割的apk文件"
until [[ $Number -eq 0 ]]; do
    read -u6
    {
    echo "- 开始推送$Number"
    apk_list=`unzip -l "$File" | egrep '\.apk'$ | sed -n ${Number}p | awk '/.*\.apk$/{print "unzip -p \"'"$File"'\" \""$4"\" | pm install-write -S "$1" '"$session_id"' '"$Number"'.apk"}'`
    eval $apk_list 1>/dev/null
    [[ $? -ne 0 ]] && abort "！推送失败，无法安装$name"
    echo >&6
    } &
    Number=$((Number-1))
done
    echo "- 等待执行完毕……"
    for i in `seq $Number_of_threads`; do read -u6; done
    exec 6>&-
    exec 6<&-
    
    echo -e "\n- 开始安装……"
    pm install-commit $session_id 1>/dev/null
    result=$?
    if [[ $result -eq 0 ]]; then
        echo "- $name成功安装"
        $Delete_APK && rm -f "$File"
        sleep 3
        exit $result
    else
        pm install-abandon $session_id
        abort "！$name安装失败"
    fi
