#本脚本由　by Han | 情非得已c，编写
#应用于搞机客上


hd() {
    for i in `seq ${#1} -2 0`; do
        echo -n "${1:$i:2}"
    done
}

size() {
    printf "%d" 0x$(hd `hexdump -s $((p3+18)) -n 4 -v -e '/1 "%02X"' "$IMG"`)
    echo -n x
    printf "%d" 0x$(hd `hexdump -s $((p3+22)) -n 4 -v -e '/1 "%02X"' "$IMG"`)
}

get_gzip_offset() {
    [[ $# -eq 0 ]] && return 1
    pyl=$1
    shift
    p=`echo "$@" | tr -d ' ' | sed -n '/1f8b08/p'`
    if [[ -n $p ]]; then
        mkch -r $TMPDIR
        p2=`echo -n $p | sed 's/1f8b08.*//' | wc -m`
        p3=`awk "BEGIN{print $pyl+($p2/2)}"`
        echo "- 检测到gzip压缩数据开始解压缩后重新分析……"
        dd if=$IMG skip=1 bs=${p3}c | gzip -d >$TMPDIR/1.img 
        IMG=$TMPDIR/1.img
        img=$IMG
    fi
}

get_offset() {
    [[ $# -eq 0 ]] && return 1
    pyl=$1
    shift
    p=`echo "$@" | tr -d ' ' | sed -rn '/424d.{8}0{8}/p'`
    if [[ -n $p ]]; then
        Number=$((Number+1))
        p2=`echo -n $p | sed 's/424d.*//' | wc -m`
        p3=`awk "BEGIN{print $pyl+($p2/2)}"`
        b=`echo "$@" | tr -d ' ' | sed -rn 's/.*424d//p'`
        b2=${b:0:8}
        b3=`hd $b2`
        b4=`printf "%d" 0x$b3`
        offset[$Number]=$p3
        bmp_size[$Number]=$b4
        bmp_fbl[$Number]=`size`
    fi
}



[[ -z `which od` ]] && abort "！未找到od命令"

Number=0

if [[ $1 = -d ]]; then
    echo "File_Dir=$File_Dir" >$CONFIG_DIR/Install_BootAnimation_Screen1_Format.log
    name=`basename "$File"`
    lu=
    lu2="$File_Dir/$Time"
    img="$File"
    IMG="$File"
    jian=$Status
    q='文件'
    unset q2
else
    name=`basename $IMG`.img
    lu=~/resources/bootanimation_screen1/customize
    lu2=$GJZS/customize_BootAnimation_Screen1
    img=$lu/$name
    jian=$lu/Configuration.log
    [[ ! -d $lu ]] && mkdir -p "$lu"
    q='分区，请切换分区解析'
    q2="，目前尚未支持您的机型：`getprop ro.product.model`"
fi




echo "- 正在分析$name"
[[ -z `strings $IMG` ]] && abort "！$name为空$q"

echo "- 正在解析$name"
Start_Time

if [[ $1 = -d ]]; then
while read line ; do
    get_gzip_offset $line
done <<Han
`od -w16 -Ad -tx1 "$IMG" | sed -rn '/1f 8b 08/{N;p}; /1f$/{N;/1f\n.* 8b 08/p}' | sed 'N; s/\n/ %/' | sed -rn 's/%[^ ]* //p'`
Han
fi

while read line ; do
    get_offset $line
done <<Han
`od -w16 -Ad -tx1 "$IMG" | sed -rn '/42 4d/{N;p}; /42$/{N;/42\n.* 4d .{44}/p}' | sed 'N; s/\n/ %/' | sed -rn 's/%[^ ]* //p'`
Han

# echo "- 解析用时：${SECONDS}s"
End_Time 解析$name

if [[ $Number -eq 0 ]]; then
    abort "！未找到.bmp格式图片$q2"
else
    echo "- 共找到$Number张bmp图片"
    [[ ! -d $lu2 ]] && mkdir -p "$lu2"
    if [[ $1 = -d ]]; then
        echo "- 开始生成配置文件并提取"
    else
        echo "- 已支持您的设备并生成配置文件"
        echo "- 配置文件生成一次在不清除搞机客数据的时候无需重复生成"
        echo "- 提取出$name……"
        dd if=$IMG of="$img"
    fi
    echo "IMG=$IMG" >$jian
    echo "Picture=$Number" >>$jian
    echo "IMG_Name=$name" >>$jian
    z=0
        for i in `seq $Number`; do
            z=$((z+1))
            echo "offset[$i]=${offset[$i]}" >>$jian
            echo "bmp_size[$i]=${bmp_size[$i]}" >>$jian
            echo "bmp_fbl[$i]=${bmp_fbl[$i]}" >>$jian
        done
            z=$((z+1))
            size=`wc -c < $img`
            echo "offset[$z]=$size" >>$jian
                z=0
                j=1
                . $jian
                PATH+=':/data/data/com.termux/files/usr/bin'
                echo "- 开始解包$name"
                if [[ $1 != -d ]]; then
                    rm -rf $lu2/*
                    cp -f "$img" "$lu2/原$name"
                fi
                    for e in ${bmp_size[@]}; do
                        z=$((z+1))
                        j=$((j+1))
                        bsize=${offset[$z]}
                        bsize2=${offset[$j]}
                        msize=$((bsize2-bsize))
                        echo "bmp_max[$z]=$msize" >>$jian
                        dd if=$img of="$lu2/$z.bmp" skip=$bsize count=$e bs=1
                        [[ $1 != -d && -n `which convert` ]] && convert -resize 540 "$lu2/$z.bmp" $lu/$z.png
                    done
                        if [[ $1 = -d ]]; then
                            echo "- 解包完成，输出路径：$lu2"
                        else
                            touch $lu2/禁止更改这里的图片和存放东西 $lu2/.nomedia
                            echo "- 已解包完成请按解压出来的图片名称自定义ps要修改的图片，原$name也备份在这个目录里"
                            echo "- 路径：$lu2，禁止更改这个目录的文件，否则需要重新解析才能得出图片，并会自动清空这个目录"
                            if [[ $ABI != arm64* ]]; then
                                echo "- PS注意事项："
                                echo "1.图片分辨率必须和原来的一致"
                                echo "2.图片必须.bmp格式，别异想天开改个后缀就是bmp格式了"
                                echo "3.最终做好的bmp成品图片不能大于我提示的字节"
                            fi
                        fi
                        rm -rf $TMPDIR
fi
End_Time 分解$name总
