#本脚本由　by Han | 情非得已c，编写
#应用于搞机客上



id=Han.automatic.rescue
mask -m ${id}
. $MWD $id
version0=$version
versionCode0=$versionCode
RUN_THE_RECORD=$Module/运行记录.txt
show=true
MODNUM=`ls $Modules_Dir | wc -l`
FenGe='------------------ 分割线 ------------------\n'
[[ -d $Modules_Dir/riru-core ]] && Riru=false || Riru=true


if [[ -d $Module ]]; then
    title="重装「$name」"
    if [[ -f $Module_XinXi.bak ]]; then
        title="已安装「$name」，等待重启中"
    elif [[ $versionCode -lt $versionCode0 ]]; then
        title="更新「$name」"
    fi
        desc="版本：$version0\n版本号：$versionCode0\n已安装：$version（$versionCode）\n作者：$author\n描述：$description\n更新于：$time"
else
    title="未安装「$name」"
    desc="版本：$version0\n版本号：$versionCode0\n作者：$author\n描述：$description\n更新于：$time"
fi
    PID=`pgrep -fl "$Module/"`
    [[ -n $PID ]] && k=false || k=true
    [[ -d $Module ]] && show_u=false || show_u=true


cat <<Han
[
    {
        "All in one": {
            "title": "$title",
            "desc": "$desc",
            "shell": ". ./magisk_module/han.automatic.rescue.sh ${id}",
            "params": [
                {
                    "type": "text",
                    "value": "使用须知：\n如果某模块在安装时直接修改系统某些文件造成的无法开机，这种情况下，「$name」是无法自动救砖的！毕竟我不是神"
                },
                {
                    "name": "ChongQi",
                    "label": "完成后自动重启系统？",
                    "type": "switch",
                    "value-sh": "grep_prop ChongQi $CONFIG_DIR/${id}.log || echo false"
                },
                {
                    "name": "RUN_THE_RECORD",
                    "label": "启用运行记录？",
                    "desc": "记录「$name」运行日志（一般不推荐关闭）",
                    "type": "switch",
                    "value-sh": "grep_prop RUN_THE_RECORD $CONFIG_DIR/${id}.log || echo true"
                },
                {
                    "type": "text",
                    "value": "方案① - 第一屏时"
                },
                {
                    "name": "Scheme2",
                    "label": "启用方案①？",
                    "value-sh": "grep_prop Scheme2 $CONFIG_DIR/${id}.log || echo true",
                    "type": "switch"
                },
                {
                    "name": "CS",
                    "title": "重启第几次后执行方案①？",
                    "type": "seekbar",
                    "max": 9,
                    "min": 2,
                    "value-sh": "grep_prop CS $CONFIG_DIR/${id}.log || echo 2"
                },
                {
                    "name": "Clean",
                    "label": "清除系统包名缓存数据",
                    "desc": "刷入一些替换系统apk模块后，导致无法开机问题去清除系统包名缓存数据",
                    "type": "checkbox",
                    "value-sh": "grep_prop Clean $CONFIG_DIR/${id}.log || echo true"
                },
                {
                    "name": "sapp",
                    "label": "冻结系统应用导致无法开机",
                    "type": "checkbox",
                    "value-sh": "grep_prop sapp $CONFIG_DIR/${id}.log || echo true"
                },
                {
                    "name": "SELinux",
                    "label": "关闭SELinux",
                    "desc": "同时为有的模块可能需要关闭SELinux才可以开机去尝试关闭SELinux",
                    "value-sh": "grep_prop SELinux $CONFIG_DIR/${id}.log || echo true",
                    "type": "checkbox"
                },
                {
                    "type": "text",
                    "value": "方案② - 第一屏时"
                },
                {
                    "name": "Frequency",
                    "title": "再重启多少次后仍无法开机强制自动救砖",
                    "desc": "注：如果方案①启用时，必须比方案①设置的值大，如果方案①没有启用时可把这里改为最小值2",
                    "type": "seekbar",
                    "max": 9,
                    "min": 2,
                    "value-sh": "grep_prop Frequency $CONFIG_DIR/${id}.log || echo 3"
                },
                {
                    "name": "Compulsory_Rescue",
                    "title": "设置强制自动救砖操作",
                    "type":"Spinner",
                    "desc": "如果重启几次后或无限在第一屏重启几次后，还是未能开机强制救砖要执行的操作。",
                    "options-sh": "cat ./magisk_module/han.automatic.rescue_options2.sh || echo Disable_and_recovery",
                    "value-sh": "grep_prop Compulsory_Rescue $CONFIG_DIR/${id}.log || echo Disable_and_recovery",
                    "required": true
                },
                {
                    "type": "text",
                    "value": "方案③ - 进入第二屏时"
                },
                {
                    "name": "update",
                    "label": "系统更新后第一次开机时停用",
                    "desc": "系统更新后第一次开机时停用「$name」，因为系统更新后第一次重启开机时间会比正常开机时间要长，导致超过方案③设置时间触发自动救砖",
                    "value-sh": "grep_prop update $CONFIG_DIR/${id}.log || echo true",
                    "type": "checkbox"
                },
                {
                    "name": "dpi",
                    "label": "检测屏幕DPI",
                    "desc": "已开机发现屏幕dpi不在250 ~ 700之间，自动恢复默认",
                    "type": "checkbox",
                    "value-sh": "grep_prop dpi $CONFIG_DIR/${id}.log || echo true"
                },
                {
                    "name": "size",
                    "label": "锁定屏幕分辨率大小",
                    "desc": "已开机发现屏幕分辨率不等于安装模块时锁定的值时，自动恢复默认。\n警告：请确保当前分辨率正常后再安装",
                    "type": "checkbox",
                    "value-sh": "grep_prop size $CONFIG_DIR/${id}.log || echo true"
                },
                {
                    "name": "UI",
                    "label": "检测系统界面UI",
                    "desc": "已开机发现系统界面UI进程不存在时，触发方案③的救砖操作。例如：使用模块方式替换系统界面导致加载异常时。\n当系统界面被冻结时，开机后发现被冻结，立即启用并重启",
                    "type": "checkbox",
                    "value-sh": "grep_prop UI $CONFIG_DIR/${id}.log || echo true"
                },
                {
                    "name": "Riru3",
                    "label": "把Riru放在最后一个禁用",
                    "desc": "当自动救砖操作选择②时生效",
                    "type": "checkbox",
                    "value-sh": "grep_prop Riru3 $CONFIG_DIR/${id}.log || echo true",
                    "hide": $Riru
                },
                {
                    "name": "Set_Time",
                    "title": "等待时间",
                    "desc": "已进入第二屏时的等待时间（单位：分钟），如果在已设定的时间过后未开机，执行方案③的自动救砖操作。\n警告：\n请根据自己手机正常开机时间去设置适当的值，如果设置的比正常开机短会造成无法开机的后果。",
                    "type": "EditText",
                    "limit": "decimals",
                    "required": true,
                    "value-sh": "grep_prop Set_Time $CONFIG_DIR/${id}.log || echo 1.2"
                },
                {
                    "name": "Automatic",
                    "title": "设置自动救砖操作",
                    "type":"Spinner",
                    "options-sh": "cat ./magisk_module/han.automatic.rescue_options3.sh",
                    "value-sh": "grep_prop Automatic $CONFIG_DIR/${id}.log || echo 'Disable'",
                    "required": true
                },
                {
                    "name": "CD_num3",
                    "title": "自定义禁用模块个数",
                    "desc": "当自动救砖操作选择②时生效（按最后修改时间排序），当前已安装了$MODNUM个模块",
                    "type": "seekbar",
                    "max": $MODNUM,
                    "min": 1,
                    "value-sh": "grep_prop CD_num3 $CONFIG_DIR/${id}.log || echo 1"
                },
                {
                    "type": "text",
                    "value": "方案④ - 进入第二屏时"
                },
                {
                    "name": "Scheme4",
                    "label": "启用方案④？",
                    "desc": "在进入第二屏时自定义音量+/-要执行的操作",
                    "value-sh": "grep_prop Scheme4 $CONFIG_DIR/${id}.log || echo false",
                    "type": "switch"
                },
                {
                    "name": "Set_Time4",
                    "title": "限定多少秒内有效",
                    "desc": "请不要的过于大否则开机后按音量键依然还可以触发方案④",
                    "type": "seekbar",
                    "max": 45,
                    "min": 15,
                    "value-sh": "grep_prop Set_Time4 $CONFIG_DIR/${id}.log || echo 30"
                },
                {
                    "name": "Record_volume_button",
                    "label": "录制音量键属性值",
                    "desc": "大多数情况下您无需勾选哦，即使您没有录制过、系统升级后我也增加了重新检测",
                    "type": "checkbox",
                    "value-sh": "grep_prop Record_volume_button $CONFIG_DIR/${id}.log || echo false"
                },
                {
                    "name": "Riru4",
                    "label": "把Riru放在最后一个禁用",
                    "desc": "当音量+/-执行操作选择②时生效",
                    "type": "checkbox",
                    "value-sh": "grep_prop Riru4 $CONFIG_DIR/${id}.log || echo false",
                    "hide": $Riru
                },
                {
                    "name": "Volume_button_frequency",
                    "title": "按音量键几次后触发？",
                    "type": "seekbar",
                    "max": 6,
                    "min": 1,
                    "value-sh": "grep_prop Volume_button_frequency $CONFIG_DIR/${id}.log || echo 2"
                },
                {
                    "name": "KEY_VOLUMEUP",
                    "title": "$FenGe音量+执行",
                    "type":"Spinner",
                    "options-sh": "cat ./magisk_module/han.automatic.rescue_options4.sh",
                    "value-sh": "grep_prop KEY_VOLUMEUP $CONFIG_DIR/${id}.log || echo 0",
                    "required": true
                },
                {
                    "name": "CD_num_UP",
                    "title": "自定义禁用模块个数",
                    "desc": "当音量+执行操作选择②时生效（按最后修改时间排序），当前已安装了$MODNUM个模块",
                    "type": "seekbar",
                    "max": $MODNUM,
                    "min": 1,
                    "value-sh": "grep_prop CD_num_UP $CONFIG_DIR/${id}.log || echo 1"
                },
                {
                    "name": "Specifies_MOD_Disable_UP",
                    "title": "自定义禁用指定模块",
                    "desc": "当音量+执行操作选择③时生效",
                    "type":"Selector",
                    "options-sh": ". ./magisk_module/get_modules_list4.sh",
                    "multi": true,
                    "value-sh": "cat $Module/Han/disable_list_UP.log"
                },
                {
                    "name": "KEY_VOLUMEDOWN",
                    "title": "$FenGe音量-执行",
                    "type":"Spinner",
                    "options-sh": "cat ./magisk_module/han.automatic.rescue_options4.sh",
                    "value-sh": "grep_prop KEY_VOLUMEDOWN $CONFIG_DIR/${id}.log || echo 0",
                    "required": true
                },
                {
                    "name": "CD_num_DOWN",
                    "title": "自定义禁用模块个数",
                    "desc": "当音量-执行操作选择②时生效（按最后修改时间排序），当前已安装了$MODNUM个模块",
                    "type": "seekbar",
                    "max": $MODNUM,
                    "min": 1,
                    "value-sh": "grep_prop CD_num_DOWN $CONFIG_DIR/${id}.log || echo 1"
                },
                {
                    "name": "Specifies_MOD_Disable_DOWN",
                    "title": "自定义禁用指定模块",
                    "type":"Selector",
                    "desc": "当音量-执行操作选择③时生效",
                    "options-sh": ". ./magisk_module/get_modules_list4.sh",
                    "multi": true,
                    "value-sh": "cat $Module/Han/disable_list_DOWN.log"
                }
            ]
        }
    },
Han

if [[ -f $RUN_THE_RECORD || -f $RUN_THE_RECORD.bak ]]; then
show=false
    echo '{"Div":{"value":"运行记录.txt"}},'
if [[ -f $RUN_THE_RECORD ]]; then
cat <<Han
    {
        "Texts": {
            "params": [
                {
                    "value-sh": "cat $RUN_THE_RECORD"
                }
            ]
        }
    },
Han
fi

if [[ -f $RUN_THE_RECORD.bak ]]; then
cat <<Han
    {
        "All in one": {
            "title": "触发方案②最后的强制救砖后保留的运行记录",
            "shell": ". ./magisk_module/han.automatic.rescue_test.sh -old_log",
            "params": [
                {
                    "name": "Way",
                    "type":"Spinner",
                    "options": [
                        "c|③　查看",
                        "d|①　删除"
                    ]
                }
            ]
        }
    },
Han
fi
fi


cat <<Han
    {
        "Div": {
            "value": "其它"
        }
    },
    {
        "Run": {
            "meta": {
                "hide": $k,
                "reload": true
            },
            "title": "强制停止「$name」模块进程",
            "summary": "当前PID：\n$PID\n正常情况下无需强制停止，等待方案③设置时间过后会自杀",
            "shell": ". ./magisk_module/han.automatic.rescue_test.sh -kill"
        }
    },
    {
        "Run": {
            "meta": {
                "log": "toast",
                "confirm": true,
                "reload": true,
                "hide": $show
            },
            "title": "删除运行记录.txt",
            "shell": ". ./magisk_module/han.automatic.rescue_test.sh -d_log"
        }
    },
    {
        "Run": {
            "meta": {
                "log": "hide",
                "confirm": true,
                "reload": true,
                "hide": $show_u
            },
            "title": "卸载「$name」",
            "shell": ". ./magisk_module/han.automatic.rescue_test.sh -uninstall"
        }
    },
    {
        "All in one": {
            "title": "一键启用/禁用所有Magisk模块",
            "summary": "- 已检测到您安装了$List个模块",
            "shell": ". ./magisk_module/modules_management.sh -\$STATE",
            "meta": {
                "log": "hide"
            },
            "params": [
                {
                    "options": [
                        "ea|启用所有模块",
                        "da|禁用所有模块"
                    ],
                    "type": "Spinner",
                    "name": "STATE",
                    "value": "ea"
                }
            ]
        }
    },
    {
        "Div": {
            "value": "安装测试模块"
        }
    },
    {
        "Texts": {
            "params": [
                {
                    "size": 26,
                    "color": "#FF9C27B0",
                    "value": "本分组功能只是为了测试「$name」是否能够自动救砖，请确保您已备份好数据或有自救能力再尝试安装",
                    "br": 2
                },
                {
                    "size": 26,
                    "color": "#FF9C27B0",
                    "value": "免责申明：\n一旦使用了本分组功能，出现的一切后果请自行承担风险，与本人无关"
                }
            ]
        }
    },
    {
        "All in one": {
            "title": "安装「老子不想开机」模块",
            "desc": "用于测试「$name」方案③是否能够自动救砖。原理：使用空文件替换安卓系统，然后会一直卡在第二屏开机动画状态下无法开机",
            "summary": "请安装此测试模块时，不要开启方案①开关，因为会误触发方案①设置。",
            "shell": ". ./magisk_module/han.automatic.rescue_test.sh BuXiangKaiJi",
            "params": [
                {
                    "name": "ChongQi",
                    "label": "是否自动重启系统开始测试？",
                    "type": "switch"
                }
            ]
        }
    },
    {
        "All in one": {
            "title": "安装「无限第一屏重启」模块",
            "desc": "用于测试「$name」方案②，是否能够再第一屏无限重启时自动救砖。原理：在模块安装目录的post-fs-data.sh脚本里加入一行重启代码",
            "summary": "请安装此测试模块时，不要开启方案①开关，因为会误触发方案①设置。",
            "shell": ". ./magisk_module/han.automatic.rescue_test.sh WuXianChongQi",
            "params": [
                {
                    "name": "ChongQi",
                    "label": "是否自动重启系统开始测试？",
                    "type": "switch"
                }
            ]
        }
    },
    {
        "All in one": {
            "title": "安装「使系统界面异常」模块",
            "desc": "用于测试「$name」方案③检测系统界面UI是否能够自动救砖。原理：使用空文件替换系统界面，虽然可以开机但是使用不了应用",
            "summary": "请安装此测试模块时，不要开启方案①开关，因为会误触发方案①设置。",
            "shell": ". ./magisk_module/han.automatic.rescue_test.sh UiYiChang",
            "params": [
                {
                    "name": "ChongQi",
                    "label": "是否自动重启系统开始测试？",
                    "type": "switch"
                }
            ]
        }
    },
    {
        "All in one": {
            "title": "冻结系统界面",
            "desc": "用于测试「$name」方案③检测系统界面UI是否能够再成功开机后0等待自动恢复默认并重启手机",
            "shell": ". ./magisk_module/han.automatic.rescue_test.sh -dui",
            "params": [
                {
                    "name": "ChongQi",
                    "label": "是否自动重启系统开始测试？",
                    "type": "switch"
                }
            ]
        }
    },
    {
        "All in one": {
            "title": "修改错误的dpi和分辨率",
            "desc": "用于测试「$name」方案③是否能够再成功开机后0等待自动恢复默认",
            "shell": ". ./magisk_module/han.automatic.rescue_test.sh -wm",
            "params": [
                {
                    "name": "ChongQi",
                    "label": "是否自动重启系统开始测试？",
                    "type": "switch"
                }
            ]
        }
    }
]
Han
