#本脚本由　by Han | 情非得已c，编写
#应用于搞机客上



_install() {
    local p
    Clean_install
    p=`pm path $1 | sed 's/.*://'`
    [[ -z $p ]] && abort "！获取$2 apk路径错误：$p"
    case $p in
        /system/*)
        :;;
        
        /system_ext/*)
            p=/system$p
        ;;
        
        *)
            abort "！未知路径：$p"
        ;;
    esac
        mktouch $Module$p
        module_prop
}


id1=$1
mask -m Han.automatic.rescue
RUN_THE_RECORD=$Module/运行记录.txt
name2='神仙自动救砖'
version=v1
versionCode=1
author='by：Han | 情非得已c'

toast id1=$id1
[[ ! -d $Module ]] && abort "！已卸载/或未安装「$name2」，请不要重复执行"

case $id1 in
    -old_log)
        RUN_THE_RECORD+=.bak
        [[ ! -f $RUN_THE_RECORD ]] && echo "文件已被删除，请退出后右上角刷新当前页面"
        case $Way in
            c)
                cat $RUN_THE_RECORD
            ;;
            
            d)
                [[ -f $RUN_THE_RECORD ]] && rm -f $RUN_THE_RECORD
                echo "文件已被删除，请退出后右上角刷新当前页面"
                sleep 2
            ;;
        esac
                exit 0
    ;;
    
    -uninstall)
        rm -rf $Module
        toast "- 已卸载$name2，已立即生效无需重启手机"
        exit 0
    ;;
        
    -d_log)
        [[ ! -f $RUN_THE_RECORD ]] && abort "！已删除请不要重复执行"
        rm -rf $RUN_THE_RECORD*
        echo 已删除了运行记录.txt 并刷新界面
        exit 0
    ;;
    
    -kill)
        echo "- 列出「$name2」模块已创建进程"
        pgrep -f "$Module/" || abort "！已被「$name2」模块，超过方案③设置的时间后自杀掉进程了"
        pkill -9 -f "$Module/"
        echo "- 再次查询一次进程"
        pgrep -f "$Module/"
        exit 0
    ;;
esac


[[ -f $Module/module.prop.bak ]] && abort "！「$name2」正在等待重启中，请重启手机后再重新安装"
mask -vc

case $id1 in
    -wm)
        [[ `grep 'wm ' $Module/Han/2.sh | wc -l` -ne 5 ]] && abort "！请开启方案①开关，并同时打勾「检测屏幕DPI」和「检测屏幕分辨率太小」后重试"
        wm density 720
        wm size 1000x1800
    ;;
    
    -dui)
        [[ `grep -w 'com.android.systemui' $Module/Han/2.sh | wc -l` -ne 5 ]] && abort "！请开启方案①开关，并同时打勾「检测系统界面UI」后重试"
        pm disable-user com.android.systemui 
    ;;
    
    BuXiangKaiJi)
        name='老子不想开机'
        description="用于测试「$name2」方案③是否能够自动救砖。原理：使用空文件替换安卓系统，然后会一直卡在第二屏开机动画状态下无法开机"
        _install android Android系统
    ;;
    
    UiYiChang)
        [[ `grep -w 'com.android.systemui' $Module/Han/2.sh | wc -l` -ne 5 ]] && abort "！请开启方案①开关，并同时打勾「检测系统界面UI」后重试"
        name='使系统界面异常'
        description="用于测试「$name2」方案③检测系统界面UI是否能够自动救砖。原理：使用空文件替换安卓系统，然后会一直卡在第二屏开机动画状态下无法开机"
        _install com.android.systemui 系统界面
    ;;
    
    WuXianChongQi)
        name='无限第一屏重启'
        description="用于测试「$name2」方案②，是否能够再第一屏无限重启时自动救砖。原理：在模块安装目录的post-fs-data.sh脚本里加入一行重启代码"
        Clean_install
        mktouch $Module_S
        echo 'reboot' >$Module_S
        module_prop
    ;;
    
    *)
        abort "！未知选项：$id1"
    ;;
esac
