#本脚本由　by Han | 情非得已c，编写
#应用于搞机客上


start_json() {
cat <<Han >$json
[
    {
        "Run": {
            "meta": {
                "autoExit": true,
                "reload": true
            },
            "title": "刷新",
            "summary": "清除已缓存的属性信息，强制刷新数据以及刷新属性变动过后的信息",
            "shell": ". ./magisk_module/prop_value.sh $1 -s"
        }
    },
    {
        "All in one": {
            "title": "新增属性",
            "params": [
                {
                    "name": "method",
                    "type": "Spinner",
                    "title": "修改方式",
                    "desc": "方案①为使用Magisk模块方式修改，也同时支持立即生效并且当设备重启后依然生效\n方案②为直接免重启立即生效，但是当设备重启后会被系统恢复默认",
                    "options": [
                        "mask|①　Magisk模块方式修改",
                        "Direct|②　直接修改"
                    ]
                },
                {
                    "name": "delete",
                    "title": "修改/删除属性",
                    "type": "Spinner",
                    "options": [
                        "false|修改",
                        "true|删除"
                    ]
                },
                {
                    "name": "prop_name",
                    "title": "属性名称",
                    "type": "EditText",
                    "required": true
                },
                {
                    "name": "value",
                    "title": "属性值",
                    "type": "EditText",
                    "required": true
                }
            ],
            "shell": ". ./magisk_module/prop_value_modify.sh"
        }
    },
Han
}

_p() {
while read i; do
    unset prop_name value
    prop_name=${i%%=*}
    value=${i#*=}

cat <<Han >>$json
    {
        "All in one": {
            "title": "$prop_name",
            "desc": "$value",
            "shell": ". ./magisk_module/prop_value_modify.sh",
            "params": [
                {
                    "name": "method",
                    "title": "修改方式",
                    "type": "Spinner",
                    "desc": "方案①为使用Magisk模块方式修改，也同时支持立即生效并且当设备重启后依然生效\n方案②为直接免重启立即生效，但是当设备重启后会被系统恢复默认",
                    "options": [
                        "mask|①　Magisk模块方式修改",
                        "Direct|②　直接修改"
                    ]
                },
                {
                    "name": "option",
                    "type": "Spinner",
                    "title": "修改/删除属性",
                    "options": [
                        "false|修改",
                        "true|删除"
                    ]
                },
                {
                    "name": "prop_name",
                    "title": "名称",
                    "type": "EditText",
                    "value": "$prop_name"
                },
                {
                    "name": "value",
                    "title": "属性值",
                    "type": "EditText",
                    "value": "$value",
                    "required": true
                }
            ]
        }
    },
Han
    done < $tmp
}




if [[ $1 = -mask ]]; then
    file_name=magisk_system.prop.json
elif [[ $1 = -all ]]; then
    file_name=prop_value.json
fi

tmp=$TMPDIR/prop_value.ini
mkch -r $TMPDIR
json=$PAGE/$file_name
log="$CONFIG_DIR/prop_value.log"
version=10

[[ -f $log ]] && user_version=`cat $log` || user_version=0

if [[ $2 = -s ]]; then
    echo "正在刷新页面信息状态，请骚等……"
elif [[ $user_version -lt $version ]]; then
    echo $version >$log
    echo "正在更新页面信息状态，请骚等……"
elif [[ ! -f $json ]]; then
    echo "正在初始化页面信息状态，请骚等……"
    echo $version >$log
else
    exit 0
fi

Start_Time
start_json $1

if [[ $1 = -mask ]]; then
    find $Modules_Dir -name 'system.prop' | while read i; do
        egrep -v '^#' "$i" >$tmp
        which sort &>/dev/null && sort -uf $tmp -o $tmp
        modname=`grep_prop name ${i/%system.prop/module.prop}`
cat <<Han  >>$json
    {
        "Div": {
            "size": 14.8888,
            "value": "$modname（$i）",
            "color": "#FF03A86A"
        }
    },
Han
        _p
    done
elif [[ $1 = -all ]]; then
    getprop | sed -r 's/^\[|\]$//g; s/\]: \[/=/g' | sed 's/\"/\\\\"/g' >$tmp
    which sort &>/dev/null && sort -u $tmp -o $tmp
    _p
fi

rm -f $tmp
sed -i '$ s/,$//' $json
echo ']' >>$json
fjson -c $json
End_Time -t 刷新 &>/dev/null
