#本脚本由　by Han | 情非得已c，编写
#应用于搞机客上


[ $SDK -lt 21 ] && abort "! Magisk只支持Android 5及以上"

echo "- 检测设备ABI"
# Detect version and architecture
    case "$ABI" in
        arm64*)
            ARCH=arm64-v8a
            ARCH32=armeabi-v7a
        ;;
        
        arm*)
            ARCH=armeabi-v7a
            ARCH32=armeabi-v7a
        ;;
        
        x86_64*)
            ARCH=x86_64
            ARCH32=x86
        ;;
        
        x86*)
            ARCH=x86
            ARCH32=x86
        ;;
        
        *) abort "！ 未知的架构 ${ABI}，无法安装busybox";;
    esac

echo "- 对应lib目录：$ARCH"

BBBIN=$TMPDIR/busybox
unzip -oq "$Download_File" "lib/$ARCH/*" -d $TMPDIR
libpath="$TMPDIR/lib/$ARCH/libbusybox.so"
chmod 755 $libpath
mv -f $libpath $BBBIN
$BBBIN >/dev/null || abort "修复失败！"

$BBBIN unzip -oq "$Download_File" "assets/*" -d $TMPDIR

COMMONDIR=$TMPDIR/assets
CHROMEDIR=$TMPDIR/assets/chromeos
BINDIR=$TMPDIR/lib/$ARCH
[[ -z $MAGISKBIN ]] && MAGISKBIN=/data/adb/magisk

if [ ! -f $COMMONDIR/util_functions.sh ]; then
    abort "! 提取文件失败"
fi


$BBBIN unzip -ojq "$Download_File" "lib/$ARCH32/libmagisk32.so" -d $BINDIR
cd $BINDIR
for file in lib*.so; do mv -f "$file" "${file:3:${#file}-6}"; done

mkch -n -r $MAGISKBIN
cp -af $BINDIR/. $COMMONDIR/. $BBBIN $MAGISKBIN
if [[ -f $MAGISKBIN/magisk64 ]]; then
    cp -af $MAGISKBIN/magisk64 $MAGISKBIN/magisk
elif [[ -f $MAGISKBIN/magisk32 ]]; then
    cp -af $MAGISKBIN/magisk32 $MAGISKBIN/magisk
fi

chmod -R 755 $MAGISKBIN/*
