#本脚本由　by Han | 情非得已c，编写
#应用于搞机客上


which update_engine_client &>/dev/null || abort "！系统里缺少命令"

case $1 in
    -z)
        [[ ! -f $File ]] && abort "！选择的文件不存在"
        dir=`dirname $File`
        dir2=$dir/payload.bin_$Time
        mkdir $dir2 || abort "创建目录失败"
        echo "- 查看是否为50 4B 03 04头文件格式"
        hexdump -n 4 -e '/1 "%02X"' $File | egrep -q '^504B0304$' || abort "！不支持的文件格式"
        echo "- 查询$File是否有payload.bin和payload_properties.txt文件"
        unzip -l $File | egrep '\<payload.bin$' || abort "！未找到payload.bin文件"
        unzip -l $File | egrep '\<payload_properties.txt$' || abort "！未找到payload_properties.txt文件"
        echo "- 提取payload.bin……"
        unzip -o $File 'payload.bin' -d $dir2
        echo
        update_engine_client --payload=file://$dir2/payload.bin --follow --update --headers="\
        `unzip -p $File 'payload_properties.txt'`"
    ;;
    
    -b)
        [[ ! -f $txt ]] && abort "！选择的.txt文件不存在"
        [[ ! -f $bin ]] && abort "！选择的.bin文件不存在"
        echo "- 查看是否为43 72 41 55头文件格式"
        hexdump -n 4 -e '/1 "%02X"' $bin | egrep -q '^43724155$' || abort "！该文件不是payload.bin"
        echo "- 查看$txt"
        cat $txt || abort "！失败"
        echo
        update_engine_client --payload=file://$bin --follow --update --headers="\
        `cat $txt`"
    ;;
esac
    echo "- 查看更新日志"
    logcat -s update_engine:V


